<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Method;

use Services\MapNutritionistService;

class MapNutritionistController extends \Zeedhi\Framework\Controller\Simple {

    protected $mapNutritionistService;

    public function __construct(MapNutritionistService $mapNutritionistService) {
        $this->mapNutritionistService = $mapNutritionistService;
    }

    public function save(Request\DataSet $request, Response $response) {

        $patients = $request->getDataSet()->getRows();

        if($patients) {

            try {

                $this->mapNutritionistService->save($patients);

            }catch(\Exception $e) {

                $response->setError(new Error($e->getMessage(), $e->getCode()));

            };

        }

    }

    public function synchronism(Request\Filter $request, Response $response) {

        try {

            $this->mapNutritionistService->synchronism();

            $dataSet = $this->mapNutritionistService->getDataSet();

            $response->addDataSet(new DataSet ('Storeys', $dataSet['storeys']));
            $response->addDataSet(new DataSet ('Halls', $dataSet['halls']));
            $response->addDataSet(new DataSet ('HallsDistincts', $dataSet['hallsDistincts']));
            $response->addDataSet(new DataSet ('Beds', $dataSet['beds']));
            $response->addDataSet(new DataSet ('Patients', $dataSet['patients']));
            $response->addDataSet(new DataSet ('Profiles', $dataSet['profiles']));
            $response->addDataSet(new DataSet ('Prescriptions', $dataSet['prescriptions']));
            $response->addDataSet(new DataSet ('Appointments', $dataSet['appointments']));
            $response->addDataSet(new DataSet ('AnthEvaluationMethods', $dataSet['anthEvaluationMethods']));

        }catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }

    }

}