<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\ProfilesService;

class ProfilesController extends \Zeedhi\Framework\Controller\Simple {

    protected $profilesService;

    public function __construct(ProfilesService $profilesService) {
        $this->profilesService = $profilesService;
    }

    public function save(Request\DataSet $request, Response $response) {
        
        $profiles = $request->getDataSet()->getRows();
        if($profiles) {
            try {
                $dataSet = $this->profilesService->save($profiles);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };
        }
    }
}