<?php
 
namespace TecDiet\Services;

use Doctrine\ORM\EntityManager;
use TecDiet\Util\CRUD;
use TecDiet\Util\ConnectionFactory;

class IntegrationService{

    protected $entityManager;
    protected $connection;
    
    const GET_FILIAL = "SELECT CDFILIAL FROM PARAMGERAL";
    const GET_PATIENT = "SELECT CDPACIENTE FROM PACIENTE WHERE (CDFILIAL   = :P_CDFILIAL) AND (CDPACIENTE = :P_CDPACIENTE)";
    const INSERT_PATIENT = "INSERT INTO PACIENTE(CDFILIAL, CDPACIENTE, NMPACIENTE, NMSOBRNOME, IDSEXOPACI, DTNASCPACI, IDPACIENT) 
                                VALUES (:P_CDFILIAL, :P_CDPACIENTE, :P_NMPACIENTE, SUBSTR (:P_NMPACIENTE,INSTR(:P_NMPACIENTE,' ',-1,1)+1,15), :P_IDSEXOPACI,
                                :P_DTNASCPACI, :P_IDPACIENT)";
    const GET_STOREY = "SELECT CDANDAR FROM ANDAR WHERE (CDFILIAL = :P_CDFILIAL) AND (CDANDAR  = :P_CDANDAR)";
    const INSERT_STOREY = "INSERT INTO ANDAR(CDFILIAL, CDANDAR, NMANDAR) VALUES (:P_CDFILIAL, :P_CDANDAR, :P_CDANDAR)"; 
    const GET_HALL = "SELECT CDALA FROM ALA WHERE (CDFILIAL = :P_CDFILIAL) AND (CDALA = :P_CDALA)";
    const INSERT_HALL = "INSERT INTO ALA(CDFILIAL, CDALA, NMALA) VALUES (:P_CDFILIAL, :P_CDALA, :P_CDALA)";
    const GET_STOREY_HALL = "SELECT CDALA FROM ALANDAR WHERE (CDFILIAL = :P_CDFILIAL)  AND (CDALA = :P_CDALA) AND (CDANDAR  = :P_CDANDAR)";
    const INSERT_STOREY_HALL = "INSERT INTO ALANDAR(CDFILIAL, CDALA, CDANDAR) VALUES (:P_CDFILIAL, :P_CDALA, :P_CDANDAR)";
    const GET_BED = "SELECT CDLEITO FROM LEITO WHERE (CDFILIAL = :P_CDFILIAL)  AND (CDLEITO  = :P_CDLEITO)";
    const INSERT_BED = "INSERT INTO LEITO(CDFILIAL, CDLEITO, NMLEITO, CDANDAR, CDALA) VALUES (:P_CDFILIAL, :P_CDLEITO, :P_CDLEITO, :P_CDANDAR, :P_CDALA)";
    const GET_MED_TEAM = "SELECT CDEQUIMED FROM EQUIMEDI WHERE (CDFILIAL = :P_CDFILIAL)  AND (CDEQUIMED  = :P_CDEQUIMED)";
    const INSERT_MED_TEAM = "INSERT INTO EQUIMEDI(CDFILIAL, CDEQUIMED, NMEQUIMED) VALUES (:P_CDFILIAL, :P_CDEQUIMED, :P_CDEQUIMED)";
    const GET_PAD_INTER = "SELECT CDSERPADDIE FROM PADRAOSERV WHERE (CDSERPADDIE  = :P_CDSERPADDIE)";
    const INSERT_PAD_INTER = "INSERT INTO PADRAOSERV(CDSERPADDIE, NMSERPADDIE) VALUES (:P_CDSERPADDIE, :P_CDSERPADDIE)";
    const GET_INTER = "SELECT CDLEITO FROM INTERNAC WHERE (CDFILIAL = :P_CDFILIAL) AND (CDPACIENTE = :P_CDPACIENTE) AND (DTINTERNA  = :P_DTINTERNA)";
    const INSERT_INTER = "INSERT INTO INTERNAC (CDFILIAL, CDPACIENTE, DTINTERNA, DTALTA, CDEQUIMED, CDSERPADDIE, CDLEITO)
                                VALUES (:P_CDFILIAL, :P_CDPACIENTE, :P_DTINTERNA, :P_DTALTA, :P_CDEQUIMED, :P_CDSERPADDIE, :P_CDLEITO)";
    const UPDATE_INTER = "UPDATE INTERNAC SET CDLEITO = :P_CDLEITO, DTALTA  = :P_DTALTA 
                            WHERE (CDFILIAL   = :P_CDFILIAL) AND (CDPACIENTE = :P_CDPACIENTE) AND (DTINTERNA  = :P_DTINTERNA)";
    const UPDATE_BED = "UPDATE LEITO SET IDOCUPLEITO = :P_IDOCUPLEITO WHERE (CDFILIAL = :P_CDFILIAL) AND (CDLEITO  = :P_CDLEITO)";
    const GET_PRES_DIET = "SELECT MAX(P.DTPRESDIET) FROM PRESDIET P WHERE (P.CDFILIAL   = :P_CDFILIAL)   AND (P.CDPACIENTE = :P_CDPACIENTE) AND
                                (P.DTPRESDIET BETWEEN :P_DTINTERNA AND NVL(:P_DTALTA,SYSDATE))";
    const INSERT_PRES_DIET = "INSERT INTO PRESDIET (CDFILIAL,CDPACIENTE,DTPRESDIET,CDDIETPAD, DSPRESDIET,DSDADOCLIN,DSPRESMEDDIE,CDNIASNUTR,CDLEITO)
                                 SELECT CDFILIAL,CDPACIENTE, SYSDATE, CDDIETPAD, DSPRESDIET, DSDADOCLIN, DSPRESMEDDIE, CDNIASNUTR, :P_CDLEITO
                                 FROM PRESDIET P WHERE (P.CDFILIAL   = :P_CDFILIAL )  AND (P.CDPACIENTE = :P_CDPACIENTE) AND (P.DTPRESDIET = :P_DTPRESDIET)";
    const GET_LAUD_PRESC = "SELECT IDDIETAESP, CDTIPOLAUDO, DSLAUDPRES FROM LAUDPRESC WHERE (CDFILIAL   = :P_CDFILIAL)   AND (CDPACIENTE = :P_CDPACIENTE)
                                AND (DTPRESDIET = :P_DTPRESDIET)";
    const INSERT_LAUD_PRESC = "INSERT INTO LAUDPRESC (CDFILIAL, CDPACIENTE, DTPRESDIET, IDDIETAESP, CDTIPOLAUDO, DSLAUDPRES)
                                VALUES (:P_CDFILIAL, :P_CDPACIENTE, SYSDATE , :P_IDDIETAESP, :P_CDTIPOLAUDO, :P_DSLAUDPRES)";
    const GET_OBS = "SELECT IDOBSPRESC, DSOBSPRESC FROM OBSPRESC WHERE (CDFILIAL = :P_CDFILIAL) AND (CDPACIENTE = :P_CDPACIENTE) AND (DTPRESDIET = :P_DTPRESDIET)";
    const INSERT_OBS = "INSERT INTO OBSPRESC (CDFILIAL, CDPACIENTE, DTPRESDIET, IDOBSPRESC, DSOBSPRESC) 
                            VALUES (:P_CDFILIAL, :P_CDPACIENTE, SYSDATE, :P_IDOBSPRESC, :P_DSOBSPRESC)";
    const GET_OCORR_PRESC = "SELECT NROCORPRES, DTOCORPRES, IDOCORPRES, DSOCORPRES, VRCOMPLOCPRE FROM OCORPRESC WHERE (CDFILIAL   = :P_CDFILIAL)   AND
                                (CDPACIENTE = :P_CDPACIENTE) AND (DTPRESDIET = :P_DTPRESDIET)";
    const INSERT_OCORR_PRESC = "INSERT INTO OCORPRESC (CDFILIAL, CDPACIENTE, DTPRESDIET, NROCORPRES, DTOCORPRES, IDOCORPRES, DSOCORPRES, VRCOMPLOCPRE)
                                VALUES(:P_CDFILIAL, :P_CDPACIENTE, SYSDATE, :NROCORPRES, :DTOCORPRES, :IDOCORPRES, :DSOCORPRES, :VRCOMPLOCPRE)";

    public function __construct(EntityManager $entityManager, $config, $eventManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
        $this->config = $config;
        $this->eventManager = $eventManager;
    }
    
    public function connectIntegration() {
        $connectionParams = $this->entityManager->getConnection()->getParams();
        $this->entityManager = ConnectionFactory::returnEntity($connectionParams, $this->config, $this->eventManager);
    }

    public function getPatient($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_PATIENT);

        $sth->execute(array(
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertPatient($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_PATIENT);
        $sth->execute($params);
    }
    
    public function getStorey($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_STOREY);

        $sth->execute(array(
            'P_CDANDAR' => $params['andar'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertStorey($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_STOREY);
        $sth->execute(array(
            'P_CDANDAR' => $params['andar'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
    }
    
    public function getHall($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_HALL);

        $sth->execute(array(
            'P_CDALA' => $params['ala'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertHall($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_HALL);
        $sth->execute(array(
            'P_CDALA' => $params['ala'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
    }
    
    public function getStoreyHall($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_STOREY_HALL);

        $sth->execute(array(
            'P_CDALA' => $params['ala'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertStoreyHall($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_STOREY_HALL);
        $sth->execute(array(
            'P_CDALA' => $params['ala'],
            'P_CDANDAR' => $params['andar'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
    }
    
    public function getBed($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_BED);

        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertBed($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_BED);
        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_CDALA' => $params['ala'],
            'P_CDANDAR' => $params['andar'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
    }
    
    public function getMedTeam($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_MED_TEAM);

        $sth->execute(array(
            'P_CDEQUIMED' => $params['equipe_medica'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertMedTeam($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_MED_TEAM);
        $sth->execute(array(
            'P_CDEQUIMED' => $params['equipe_medica'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
    }
    
    public function getPadInter($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_PAD_INTER);

        $sth->execute(array(
            'P_CDSERPADDIE' => '',
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertPadInter($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_PAD_INTER);
        $sth->execute(array(
            'P_CDSERPADDIE' => '',
        ));
    }
    
    public function getInter($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_INTER);

        $sth->execute(array(
            'P_DTINTERNA' => $this->formatDate($params['data_internacao'], 'd/m/Y H:i:s'),
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertInter($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_INTER);
        $sth->execute(array(
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_DTINTERNA' => $this->formatDate($params['data_internacao'], 'd/m/Y H:i:s'),
            'P_DTALTA' => $this->formatDate($params['data_alta'], 'd/m/Y H:i:s'),
            'P_CDEQUIMED' => $params['equipe_medica'],
            'P_CDSERPADDIE' => '',
            'P_CDLEITO' => $params['leito'],
        ));
    }
    
    public function updateInter($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::UPDATE_INTER);
        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_DTALTA' => $this->formatDate($params['data_alta'], 'd/m/Y H:i:s'),
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_DTINTERNA' => $this->formatDate($params['data_internacao'], 'd/m/Y H:i:s'),
        ));
    }
    
    public function updateBed($params, $idocupleito) {
        $sth = $this->entityManager->getConnection()->prepare(self::UPDATE_BED);
        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_IDOCUPLEITO' => $idocupleito
        ));
    }
    
    public function getPresDiet($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_PRES_DIET);
        $sth->execute(array(
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_DTINTERNA' => $this->formatDate($params['data_internacao'], 'd/m/Y H:i:s'),
            'P_DTALTA' => $this->formatDate($params['data_alta'], 'd/m/Y H:i:s'),
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertPresDiet($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_PRES_DIET);
        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_DTPRESDIET' => $this->formatDate($params['P_DTPRESDIET'], 'd/m/Y H:i:s'),
        ));
    }
    
    public function getLaudPresc($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_LAUD_PRESC);
        $sth->execute(array(
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_DTPRESDIET' => $this->formatDate($params['P_DTPRESDIET'], 'd/m/Y H:i:s'),
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertLaudPresc($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_LAUD_PRESC);
        $sth->execute(array(
            'P_CDLEITO' => $params['leito'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_IDDIETAESP' => $params['IDDIETAESP'],
            'P_CDTIPOLAUDO' => $params['CDTIPOLAUDO'],
            'P_DSLAUDPRES' => $params['DSLAUDPRES'],
        ));
    }
    
    public function getObservation($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_OBS);
        $sth->execute(array(
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_DTPRESDIET' => $this->formatDate($params['P_DTPRESDIET'], 'd/m/Y H:i:s'),
        ));
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
    
    public function insertObservation($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_OBS);
        $sth->execute(array(
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_IDOBSPRESC' => $params['IDOBSPRESC'],
            'P_DSOBSPRESC' => $params['DSOBSPRESC'],
        ));
    }
    
    public function getOcorrPresc($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_OCORR_PRESC);
        $sth->execute(array(
            'P_CDPACIENTE' => $params['prontuario'],
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_DTPRESDIET' => $this->formatDate($params['P_DTPRESDIET'], 'd/m/Y H:i:s'),
        ));
        return $sth->fetch(\PDO::FETCH_ALL);
    }
    
    public function insertOcorrPresc($params) {
        $sth = $this->entityManager->getConnection()->prepare(self::INSERT_OBS);
        $sth->execute(array(
            'P_CDFILIAL' => $params['CDFILIAL'],
            'P_CDPACIENTE' => $params['prontuario'],
            'P_NROCORPRES' => $params['NROCORPRES'],
            'P_DTOCORPRES' => $params['DTOCORPRES'],
            'P_IDOCORPRES' => $params['IDOCORPRES'],
            'P_DSOCORPRES' => $params['DSOCORPRES'],
            'P_VRCOMPLOCPRE' => $params['VRCOMPLOCPRE'],
        ));
    }
    
    private function formatDate($date, $format) {
        if ($date !== null) {
            return \DateTime::createFromFormat('Y-m-d H:i:s', $date, new \DateTimeZone('America/Sao_Paulo'))->format($format);
        } else return $date;
    }
    
    public function getFilial() {
        $sth = $this->entityManager->getConnection()->prepare(self::GET_FILIAL);
        $sth->execute();
        return $sth->fetch(\PDO::FETCH_ASSOC);
    }
}