<?php
namespace TecDiet\Services;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Events\PreDispatch\Listener;

class PreDispatch extends Listener {
    
    protected $authService;
    private $ignoredRoutes = array("/login", "/logout");

    public function __construct($authService) {
        $this->authService = $authService;
    }

    public function preDispatch(Request $request) {
        $sessionName = "session";
        if (!in_array($request->getRoutePath(), $this->ignoredRoutes)) {
            if(isset($_COOKIE[$sessionName])){
                $token = urldecode($_COOKIE[$sessionName]);
                $validToken = $this->authService->validateToken($token, $sessionName);
                if (!$validToken) {
                    throw new \Exception("invalidToken", 1);
                }
            } else {
                throw new \Exception("invalidToken", 1);
            }
        }
    }
}