var ControlFeedingController = function(localStorageEngine, Validation, ScreenService, Environment, ControlFeedingService) {

    var SERVICES = {
        NORMAL: "0",
        LACTARY: "1",
        ENTERAL: "2",
        ROOM_SERVICE: "3",
        ESPECIAL: "4"
    };
    var isNew = false;

    this.verify = function(widget) {
        if (widget.selectedRow.__alwaysSelected) {
            ScreenService.showMessage(ScreenService.i18n('Não é possível desmarcar o prato não opcional'));
            widget.selectedRow.__isSelected = true;
        }
    };

    this.verifyAll = function(widget) {
        widget.dataSource.data.forEach(function(row) {
            if (row.__alwaysSelected) {
                row.__isSelected = true;
            }
        });
    };

    this.back = function(widget) {
        ScreenService.closeSwipe();
        if (widget.name === 'WidgetLactaryFeedingFormSwipe') {
            widget.container.getWidget("WidgetLactaryFeedingSwipe").activate();

        } else if (widget.name === 'WidgetNormalFeedingSwipe') {
            widget.container.getWidget("WidgetNormalFeedingSwipe").activate();
        } else if (widget.name === 'WidgetNormalFeedingFormSwipe') {
            widget.container.getWidget("WidgetNormalFeedingSwipe").activate();
        } else {
            widget.container.getWidget("WidgetEnteralFeedingSwipe").activate();
        }
    };

    this.view = function(widget) {
        widget.template = "widget/form-view.html";
        widget.list();
    };

    this.backEvaluation = function(widget) {
        widget.unSelectAll();
        ScreenService.closeSwipe();
        widget.container.getWidget('WidgetControlFeeding').activate();
        // widget.container.getWidget('WidgetAddEvaluationFeeding').widgets[0].activate();
    };

    this.cancel = function(widget) {
        if (widget.name === 'WidgetEnteralFeedingFormSwipe') {
            ScreenService.closeSwipe();
            widget.container.getWidget('WidgetEnteralFeedingSwipe').activate();
        } else {
            widget.template = "widget/form-view.html";
            widget.list();
            ScreenService.closeSwipe();
        }
    };

    this.addEvaluation = function(widget, evaluation) {

        widget.widgets[0].newRow();
        var evaluationService = '';

        if (evaluation === '2') {
            widget.widgets[0].label = ScreenService.i18n('Adicionar Enteral/Parenteral');
            evaluationService = '1';
            widget.widgets[0].getField('date').readOnly = true;
            widget.widgets[0].getAction('next').isVisible = false;
            widget.widgets[0].getAction('confirm').isVisible = true;
        }

        if (evaluation === '1') {
            widget.widgets[0].label = ScreenService.i18n('Adicionar Lactário');
            evaluationService = '2';
            widget.widgets[0].getField('date').readOnly = true;
            widget.widgets[0].getAction('next').isVisible = false;
            widget.widgets[0].getAction('confirm').isVisible = true;
        }

        if (evaluation === '0') {
            widget.widgets[0].label = ScreenService.i18n('Adicionar Oral');
            evaluationService = '0';
            widget.widgets[0].getField('date').readOnly = false;
            widget.widgets[0].getAction('next').isVisible = true;
            widget.widgets[0].getAction('confirm').isVisible = false;
            isNew = true;
        }

        widget.widgets[0].getField('serviceName').dataSourceFilter = [{
                "name": "serviceType",
                "operator": "=",
                "value": "D"
            },
            {
                "name": "service",
                "operator": "=",
                "value": evaluationService
            },
            {
                "name": "unit",
                "operator": "=",
                "value": Environment.getLocalVar('__CDFILIAL')
            }
        ];

        widget.widgets[0].getField('serviceName').reload();
        widget.widgets[0].getField('date').value(moment().format("DD/MM/YYYY HH:MM:ss"));
        widget.widgets[0].getField('userName').value(Environment.getLocalVar('__NMOPERADOR'));

        ScreenService.closePopup();
        ScreenService.openSwipe(widget);

    };

    this.nextEvaluation = function(widget) {

        try {

            _validateFields(widget.currentRow);

            var widgetNormalFeeding = widget.container.getWidget('WidgetNormalFeeding');
            var widgetNormalFeedingSwipe = widget.container.getWidget('WidgetNormalFeedingSwipe');
            var menuDate = widget.currentRow.date.split(" ");

            var filter = [{
                    "name": "menuDate",
                    "operator": "=",
                    "value": menuDate[0] + ' 00:00:00'
                },
                {
                    "name": "unit",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar('__CDFILIAL')
                }
            ];

            widgetNormalFeedingSwipe.dataSource.data = [];
            localStorageEngine.getDataSource('/NormalFeedingsNow', filter).then(function(feedings) {

                if (feedings.length > 0) {

                    feedings.forEach(function(feeding) {
                        if (feeding.optional === 'N') {
                            feeding.__isSelected = true;
                        }
                        widgetNormalFeedingSwipe.dataSource.data.push(feeding);
                        widgetNormalFeedingSwipe.getAction('confirm').isVisible = true;
                    });

                    widgetNormalFeedingSwipe.reload().then(function() {
                        ScreenService.openSwipe(widgetNormalFeeding);
                    });

                } else {

                    var msg = ScreenService.i18n('Não existe cardápio cadastrado para a dieta e dia informado.');
                    ScreenService.showMessage(msg);
                }
            });
        } catch (exceptionMessage) {
            ScreenService.showMessage(ScreenService.i18n(exceptionMessage));
        }

    };

    this.serviceOnChange = function(widget) {
        var service = "";

        // temporary
        if (widget.currentRow.service === '1') {
            service = SERVICES.ENTERAL;
        }

        if (widget.currentRow.service === '2') {
            service = SERVICES.LACTARY;
        }

        if (widget.currentRow.service === '0') {
            service = SERVICES.NORMAL;
        }

        widget.getField('dietName').dataSourceFilter = [{
                "name": "serviceId",
                "operator": "=",
                "value": widget.currentRow.serviceId
            },
            {
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            },
            {
                "name": "service",
                "operator": "=",
                "value": service
            }
        ];

        widget.getField('dietName').reload().then(function() {
            widget.getField('dietName').value('');
        });

    };

    var _validateFields = function(fields) {

        if (!fields.date) {
            throw "Informe uma data.";
        }

        if (!fields.serviceName) {
            throw "Informe um serviço.";
        }

        if (!fields.dietName) {
            throw "Informe uma dieta.";
        }

    };

    this.saveNormalControlFeeding = function(widget) {
        ControlFeedingService.saveControlFeeding(widget, isNew).then(function(success) {
            if (success) {
                widget.container.getWidget('WidgetControlFeeding').reload().then(function() {
                    ScreenService.closeSwipe(0);
                    widget.container.getWidget('WidgetControlFeeding').activate();
                });
            }
            isNew = false;
        });
    };

    this.saveControlFeeding = function(widget) {

        try {

            _validateFields(widget.currentRow);

            ControlFeedingService.saveControlFeeding(widget.currentRow).then(function() {

                widget.container.getWidget('WidgetControlFeeding').reload().then(function() {
                    ScreenService.closeSwipe();
                    widget.container.getWidget('WidgetControlFeeding').activate();

                });

            });

        } catch (exceptionMessage) {
            ScreenService.showMessage(ScreenService.i18n(exceptionMessage));
        }

    };

    this.openSwipe = function(container) {

        var widgetMain = container.getWidget('WidgetControlFeeding');

        var widgetEnteralFeeding = container.getWidget('WidgetEnteralFeeding');
        var widgetEnteralFeedingSwipe = container.getWidget('WidgetEnteralFeedingSwipe');

        var widgetLactaryFeeding = container.getWidget('WidgetLactaryFeeding');
        var widgetLactaryFeedingSwipe = container.getWidget('WidgetLactaryFeedingSwipe');

        var widgetNormalFeeding = container.getWidget('WidgetNormalFeeding');
        var widgetNormalFeedingSwipe = container.getWidget('WidgetNormalFeedingSwipe');

        var filter = [{
                "name": "id",
                "operator": "=",
                "value": widgetMain.currentRow.id
            },
            {
                "name": "unit",
                "operator": "=",
                "value": widgetMain.currentRow.unit
            },
            {
                "name": "serviceDate",
                "operator": "=",
                "value": widgetMain.currentRow.serviceDate.substring(0, 10)
            },
            {
                "name": "sequential",
                "operator": "=",
                "value": widgetMain.currentRow.sequential
            }

        ];

        if (widgetMain.currentRow.serviceId === SERVICES.ENTERAL) {

            widgetEnteralFeedingSwipe.dataSourceFilter = filter;
            widgetEnteralFeedingSwipe.currentRow = widgetMain.currentRow;
            widgetEnteralFeedingSwipe.reload().then(function() {
                widgetEnteralFeedingSwipe.activate();
                ScreenService.openSwipe(widgetEnteralFeeding);
            });

        }

        if (widgetMain.currentRow.serviceId === SERVICES.LACTARY) {
            widgetLactaryFeedingSwipe.dataSourceFilter = filter;
            widgetLactaryFeedingSwipe.currentRow = widgetMain.currentRow;
            widgetLactaryFeedingSwipe.reload().then(function() {
                widgetLactaryFeedingSwipe.activate();
                ScreenService.openSwipe(widgetLactaryFeeding);
            });

        }

        if (widgetMain.currentRow.serviceId === SERVICES.NORMAL) {
            filter[2] = {
                "name": "serviceDate",
                "operator": "=",
                "value": widgetMain.currentRow.serviceDate.substring(0, 10)
            };
            filter.pop();
            widgetNormalFeedingSwipe.dataSource.data = [];
            localStorageEngine.getDataSource('/NormalFeedings', filter).then(function(feedings) {

                feedings.forEach(function(feeding) {
                    widgetNormalFeedingSwipe.dataSource.data.push(feeding);
                    if (feeding.isSelected) {
                        feeding.__isSelected = true;
                        feeding.__alwaysSelected = true;
                    } else {
                        feeding.__isSelected = false;
                    }
                });

                widgetNormalFeedingSwipe.reload().then(function() {
                    ScreenService.openSwipe(widgetNormalFeeding);
                });

            });

        }

    };

    this.openSubWidgetSwipe = function(widget) {

        widget.widgets[0].widgets[0].template = "widget/form-view.html";
        widget.widgets[0].widgets[0].currentRow = widget.currentRow;
        ScreenService.openSwipe(widget.widgets[0]);

    };

    this.editEnteral = function(widget) {

        widget.getField('formulationName').dataSourceFilter = [{
                "name": "preparationId",
                "operator": "=",
                "value": widget.currentRow.preparationId
            },
            {
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            }
        ];

        widget.getField('formulationName').reload();

        widget.getField('enteralDate').readOnly = true;
        widget.getField('time').readOnly = true;

        widget.template = "widget/form-view-edit.html";
        widget.edit();

    };

    this.edit = function(widget) {

        widget.template = "widget/form-view-edit.html";
        widget.edit();

    };

    this.add = function(widget) {

        var newWidget = widget.widgets[0].widgets[0];

        newWidget.fields.forEach(function(field) {
            field.readOnly = false;
        });

        newWidget.template = "widget/form.html";
        newWidget.edit();
        newWidget.newRow();

        newWidget.currentRow.unique = Validation.strPad(widget.dataSource.data.length + 1, 4);
        newWidget.currentRow.key = widget.dataSource.data.length + 1;
        newWidget.currentRow.serviceId = widget.currentRow.serviceId;
        newWidget.currentRow.id = widget.currentRow.id;
        newWidget.currentRow.unit = widget.currentRow.unit;
        newWidget.currentRow.serviceDate = widget.currentRow.serviceDate;
        newWidget.currentRow.sequential = widget.currentRow.sequential;

        ScreenService.openSwipe(widget.widgets[0]);

    };

    this.save = function(widget) {
        widget.currentRow.service = widget.container.getWidget('WidgetAddEvaluationFeedingSwipe').currentRow.service;
        widget.currentRow.changed = true;
        if (widget.name === "WidgetNormalFeedingFormSwipe") {
            ControlFeedingService.save(widget.currentRow).then(function() {
                widget.template = "widget/form-view.html";
                widget.list();
            });
        } else {
            widget.fields.forEach(function(field) {
                if ((field.validations) && (field.value() === "")) {
                    ScreenService.showMessage(ScreenService.i18n("Preencha os campos obrigatórios."));
                } else if ((field.validations) && (field.value() !== "")) {
                    ControlFeedingService.save(widget.currentRow).then(function() {

                        widget.template = "widget/form-view.html";
                        ScreenService.closeSwipe();

                        if (widget.name === 'WidgetLactaryFeedingFormSwipe') {
                            widget.container.getWidget('WidgetLactaryFeedingSwipe').reload();
                            widget.container.getWidget('WidgetLactaryFeedingSwipe').activate();

                        } else if (widget.name === 'WidgetEnteralFeedingFormSwipe') {
                            widget.container.getWidget('WidgetEnteralFeedingSwipe').reload();
                            widget.container.getWidget('WidgetEnteralFeedingSwipe').activate();

                        }
                        widget.list();
                        Environment.lastPatientVisit();

                    });
                }
            });
        }
    };

    this.preparationOnChange = function(preparationId, formulation) {
        formulation.value("");
        formulation.widget.currentRow[formulation.valueField] = "";
        formulation.widget.currentRow[formulation.descriptionField] = "";
        formulation.disabled = false;
    };

    this.onEnter = function(widget) {

        widget.reload().then(function() {
            widget.updateCheckedRows();
        });

    };

    this.widgetAfterSelectRow = function(checkedRows) {
        ControlFeedingService.saveCheckedRows(checkedRows);
    };

    this.widgetEnteralFeedingSwipeOnEnter = function() {

        var data = [{
                "preparationId": "A",
                "preparationName": ScreenService.i18n("Aberto")
            },
            {
                "preparationId": "F",
                "preparationName": ScreenService.i18n("Fechado")
            }
        ];

        localStorageEngine.setDataSource('/Preparations', data);

    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('ControlFeedingController', ControlFeedingController);
});
