var SynchronizeController = function(ScreenService, SynchronizeService, eventAggregator, templateManager, localStorageEngine) {

    this.sync = function() {
        syncService();
    };

    eventAggregator.subscribe('wscCallUpdate', syncService);

    function syncService() {
        ScreenService.showLoader();
        localStorageEngine.getDataSource('/User').then(function(user) {
            if (user.length > 0 && user[0].CDFILIALSELECIONADA !== null && user[0].CDFILIALSELECIONADA !== undefined) {
                localStorageEngine.setLocalVar('__CDFILIAL', user[0].CDFILIALSELECIONADA);
                SynchronizeService.sync().then(function(ocurredError) {
                        if (!ocurredError) {
                            ScreenService.showMessage(ScreenService.i18n('Sincronizado com Sucesso.'), 'success');
                        }
                        var widget = templateManager.container.getWidget('WidgetMain');

                        setTimeout(function() {
                            eventAggregator.publish("reloadScreenAndClearFilters", widget);
                            eventAggregator.publish("reloadMapKitchenMaid", widget);
                            menu.closeMenu(); // jshint ignore:line
                        }, 600);
                        localStorageEngine.setLocalVar('__SYNCRONIZED', true);
                        eventAggregator.publish("callCheckNutritionist", null);
                    },
                    function() {
                        ScreenService.showMessage(ScreenService.i18n('Não foi possível conectar ao servidor, tente novamente mais tarde.'));
                    });
            } else {
                // ScreenService.confirmMessage(ScreenService.i18n('Selecione uma unidade para prosseguir a sincronização.'), 'error', function() {
                //     eventAggregator.publish("openUnitPopup", templateManager.container.getWidget('WidgetUnit'));
                // }, function() {
                //     ScreenService.openWindow('Dashboard');
                // });
                ScreenService.showMessage(ScreenService.i18n('Selecione uma unidade para prosseguir a sincronização.'));
                eventAggregator.publish("openUnitPopup", templateManager.container.getWidget('WidgetUnitSync'));
            }
        }).finally(function() {
            ScreenService.hideLoader();
        });
    }
};
Configuration(function(ContextRegister) {
    ContextRegister.register('SynchronizeController', SynchronizeController);
});
