<?php

namespace TecDiet\Services;

interface Queries {
  const GET_PARAMGERAL = "SELECT CDPARGERAL FROM PARAMGERAL";
  const ALL_PLATES_BY_UNIT = "SELECT DISTINCT COMPCARD.CDFILIAL, COMPCARD.CDFILAUXPRAT, COMPCARD.CDPRATO, COMPCARD.CDTIPOPRAT, PRATO.NMPRATO, TIPOPRAT.NMTIPOPRAT, ( TIPOPRAT.NMTIPOPRAT || ' - ' || PRATO.NMPRATO ) AS NMPRATIPO, CARDADIA.CDSERVFILI, PRATO.NRORG FROM PRATO, TIPOPRAT, CNFCAMES, CARDADIA, COMPCARD, DIETPADR, DIETSERV WHERE ( CARDADIA.CDFILIAL =:CDFILIAL ) AND ( COMPCARD.CDFILIAL = CARDADIA.CDFILIAL ) AND ( COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO ) AND ( PRATO.CDPRATO = COMPCARD.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = COMPCARD.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = COMPCARD.CDTIPOPRAT ) AND ( CNFCAMES.DTREFECNFMES = CARDADIA.DTMESCARD ) AND ( CNFCAMES.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( CNFCAMES.CDFILIAL = CARDADIA.CDFILIAL ) AND ( CNFCAMES.NRSEQCNFMES = COMPCARD.NRSEQPRATCAR ) AND ( CARDADIA.CDDIETPAD = DIETSERV.CDDIETPAD ) AND ( DIETSERV.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( DIETSERV.CDFILIAL = CARDADIA.CDFILIAL (+) ) AND ( DIETPADR.CDDIETPAD = DIETSERV.CDDIETPAD ) ORDER BY NMPRATIPO";
  const ACCESS_ROADS = "SELECT CDVIACESDIET, NMVIACESDIET FROM VIACESDIET";
  const APPOINTMENTS = "SELECT ROWNUM, TO_CHAR(CONSPACI.DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') AS DTCONSPACI, CONSPACI.CDNIASNUTR, CONSPACI.CDOPERADOR, CONSPACI.CDEQUIMED, CONSPACI.IDCASOCONS, CONSPACI.IDTPPACICONS, CONSPACI.CDDIETPAD, CONSPACI.CDSERPADDIE, CONSPACI.CDFILIAL, NIASSNUTRI.NMNIASNUTR, OPERADOR.NMOPERADOR, EQUIMEDI.NMEQUIMED, DIETPADR.DSDIETPAD AS DSDIETPAD, PADRAOSERV.NMSERPADDIE, CONSPACI.VRPESOPACI AS PESO, CONSPACI.VRALTURAPACI AS ALTURA, CONSPACI.CDFILIAL FROM CONSPACI, NIASSNUTRI, OPERADOR, EQUIMEDI, PADRAOSERV, DIETPADR WHERE ( CONSPACI.CDPACIENTE =:PATIENT ) AND ( CONSPACI.CDFILIAL =:UNITS ) AND ( CONSPACI.CDOPERADOR = OPERADOR.CDOPERADOR ) AND ( CONSPACI.CDNIASNUTR = NIASSNUTRI.CDNIASNUTR (+) ) AND ( CONSPACI.CDEQUIMED = EQUIMEDI.CDEQUIMED (+) ) AND ( CONSPACI.CDFILIAL = EQUIMEDI.CDFILIAL (+) ) AND ( CONSPACI.CDSERPADDIE = PADRAOSERV.CDSERPADDIE (+) ) AND ( CONSPACI.CDDIETPAD = DIETPADR.CDDIETPAD (+) ) ORDER BY CONSPACI.DTCONSPACI DESC";
  const APPOINTMENTS_NOW = "SELECT CDPACIENTE FROM CONSPACI WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE AND DTCONSPACI = :DTCONSPACI";
  const ANTHROPOMETRIC_EVALUATION = "SELECT ROWNUM, NVL(ME.CDFILIAL, :UNITS) AS CDFILIAL, NVL(ME.CDPACIENTE, :PATIENT) AS CDPACIENTE, TO_CHAR(NVL(ME.DTCONSPACI, TO_DATE(:APPOINTMENTDATE, 'DD/MM/YYYY HH24:MI:SS')), 'DD/MM/YYYY HH24:MI:SS') AS DTCONSPACI, NVL(ME.IDTABELAAV, 'N') AS IDTABELAAV, ME.CDTABELACO, TB.CDTBMETOAVAL, TB.NMTBMETOAVAL, TB.IDTBUTILTABE, TB.CDTBREFMETOA, TB.NRCTMETOAVAL, TB.IDDETMETODOATIV, RE.NMREFEBIBL FROM REFEBIBL RE, TBMETOAVAL TB, METOAVAL ME WHERE (ME.CDFILIAL(+) = :UNITS) AND (ME.CDPACIENTE(+) = :PATIENT ) AND (ME.DTCONSPACI(+) = TO_DATE(:APPOINTMENTDATE, 'DD/MM/YYYY HH24:MI:SS') ) AND (ME.CDTBMETOAVAL(+) = TB.CDTBMETOAVAL ) AND (TB.CDTBMETOAVAL < '30' OR TB.CDTBMETOAVAL > '36' ) AND (:AGE BETWEEN TB.VRIDADEINITB AND TB.VRIDADEFINTB) AND (ME.CDTABELACO     = RE.CDREFEBIBL(+)) AND (TB.IDDETMETODOATIV = 'S') ORDER BY TB.IDSEQUMETO ";
  const ANTHROPOMETRIC_EVALUATION_GENERAL = "SELECT ROWNUM, ME.CDFILIAL, ME.CDPACIENTE, ME.DTCONSPACI, ME.IDTABELAAV, ME.CDTABELACO, TB.CDTBMETOAVAL, TB.NMTBMETOAVAL, TB.IDTBUTILTABE, TB.CDTBREFMETOA, TB.NRCTMETOAVAL, TB.IDDETMETODOATIV, RE.NMREFEBIBL, TB.VRIDADEINITB, TB.VRIDADEFINTB FROM REFEBIBL RE, TBMETOAVAL TB, METOAVAL ME WHERE (ME.CDFILIAL(+) = :P_CDFILIAL ) AND (ME.CDPACIENTE(+) = :P_CDPACIENTE ) AND (ME.DTCONSPACI(+) = :P_DTCONSPACI ) AND (ME.CDTBMETOAVAL(+) = TB.CDTBMETOAVAL ) AND (ME.CDTABELACO = RE.CDREFEBIBL(+)) AND (TB.IDDETMETODOATIV = 'S') ORDER BY TB.IDSEQUMETO";
  const ANTHROPOMETRIC_EVALUATION_METHOD = "SELECT CDPACIENTE FROM METOAVAL WHERE (CDFILIAL = :CDFILIAL ) AND (CDPACIENTE = :CDPACIENTE ) AND (DTCONSPACI = TO_DATE(:DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') ) AND (CDTBMETOAVAL = :CDTBMETOAVAL)";
  const ANTHROPOMETRIC_EVALUATION_DATA_INFO = "SELECT CDPACIENTE FROM INFOAVAL WHERE (CDFILIAL = :CDFILIAL ) AND (CDPACIENTE = :CDPACIENTE ) AND (DTCONSPACI = TO_DATE(:DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') ) AND (CDTBMETOAVAL = :CDTBMETOAVAL) AND (CDTIPODADO = :CDTIPODADO)";
  const ANTHROPOMETRIC_METHODS = "SELECT DISTINCT ME.CDFILIAL, TB.CDTBREFMETOA, TB.CDTBMETOAVAL, TB.NMTBMETOAVAL, TB.VRIDADEINITB, TB.VRIDADEFINTB FROM REFEBIBL RE, TBMETOAVAL TB, METOAVAL ME WHERE ( ME.CDFILIAL (+) =:CDFILIAL ) AND ( ME.CDTBMETOAVAL (+) = TB.CDTBMETOAVAL ) AND ( ME.CDTABELACO = RE.CDREFEBIBL (+) ) AND ( TB.IDDETMETODOATIV = 'S' ) ORDER BY NMTBMETOAVAL";
  const LACTARY_PLATES = "SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, TRANSLATE(NMPRATO,'ŠŽšžŸÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜÏÖÑÝåáçéíóúàèìòùâêîôûãõëüïöñýÿ', 'SZszYACEIOUAEIOUAEIOUAOEUIONYaaceiouaeiouaeiouaoeuionyy') AS NORMALIZEDNAME, SGUNIDADE FROM PRATO WHERE (CDFILAUXPRAT =:CDFILIAL OR CDFILAUXPRAT = 'P') AND CDNVPRATO = :CDNVPRATO";
  const ALL_PLATES = "SELECT ROWNUM, DIETSERV.CDDIETPAD AS DIETID, DIETPADR.DSDIETPAD, DIETPADR.CDDIETPAD, COMPCARD.CDFILIAL, TO_CHAR(CARDADIA.DTCARDAPIO, 'DD/MM/YYYY') AS DTCARDAPIO, COMPCARD.CDFILAUXPRAT, COMPCARD.CDPRATO, COMPCARD.CDTIPOPRAT, COMPCARD.NRORDPRATCAR, PRATO.NMPRATO, TIPOPRAT.NMTIPOPRAT, CNFCAMES.IDOPCCNFMES, CARDADIA.CDSERVFILI FROM PRATO, TIPOPRAT, CNFCAMES, CARDADIA, COMPCARD, DIETPADR, DIETSERV WHERE ( CARDADIA.CDFILIAL =:CDFILIAL ) AND ( COMPCARD.CDFILIAL = CARDADIA.CDFILIAL ) AND ( COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO ) AND ( PRATO.CDPRATO = COMPCARD.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = COMPCARD.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = COMPCARD.CDTIPOPRAT ) AND ( CNFCAMES.DTREFECNFMES = CARDADIA.DTMESCARD ) AND ( CNFCAMES.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( CNFCAMES.CDFILIAL = CARDADIA.CDFILIAL ) AND ( CNFCAMES.NRSEQCNFMES = COMPCARD.NRSEQPRATCAR ) AND ( CARDADIA.DTCARDAPIO BETWEEN TRUNC(SYSDATE) AND SYSDATE + 1 ) AND ( CARDADIA.CDDIETPAD = DIETSERV.CDDIETPAD ) AND ( DIETSERV.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( DIETSERV.CDFILIAL = CARDADIA.CDFILIAL (+) ) AND ( DIETPADR.CDDIETPAD = DIETSERV.CDDIETPAD ) ORDER BY COMPCARD.NRORDPRATCAR";
  const ALL_PLATES_PLA = "SELECT ROWNUM, COMPCARD.CDFILIAL, TO_CHAR(CARDADIA.DTCARDAPIO, 'DD/MM/YYYY') AS DTCARDAPIO, COMPCARD.CDFILAUXPRAT, COMPCARD.CDPRATO, COMPCARD.CDTIPOPRAT, COMPCARD.NRORDPRATCAR, PRATO.NMPRATO, TIPOPRAT.NMTIPOPRAT, CNFCAMES.IDOPCCNFMES, CARDADIA.CDSERVFILI FROM PRATO, TIPOPRAT, CNFCAMES, CARDADIA, COMPCARD WHERE ( CARDADIA.CDFILIAL =:CDFILIAL ) AND ( COMPCARD.CDFILIAL = CARDADIA.CDFILIAL ) AND ( COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO ) AND ( PRATO.CDPRATO = COMPCARD.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = COMPCARD.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = COMPCARD.CDTIPOPRAT ) AND ( CNFCAMES.DTREFECNFMES = CARDADIA.DTMESCARD ) AND ( CNFCAMES.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( CNFCAMES.CDFILIAL = CARDADIA.CDFILIAL ) AND ( CNFCAMES.NRSEQCNFMES = COMPCARD.NRSEQPRATCAR ) AND ( CARDADIA.DTCARDAPIO BETWEEN TRUNC(SYSDATE) AND SYSDATE + 1 ) AND ( CARDADIA.CDDIETPAD IS NULL ) ORDER BY COMPCARD.NRORDPRATCAR";
  const BEDS = "SELECT DISTINCT LEITO.CDANDAR, LEITO.CDALA, LEITO.CDLEITO, LEITO.CDFILIAL, LEITO.NMLEITO, ANDAR.NMANDAR, ALA.NMALA FROM LEITO INNER JOIN ANDAR ON LEITO.CDANDAR = ANDAR.CDANDAR AND LEITO.CDFILIAL = ANDAR.CDFILIAL INNER JOIN ALA ON LEITO.CDALA = ALA.CDALA AND LEITO.CDFILIAL = ALA.CDFILIAL WHERE LEITO.CDFILIAL = :CDFILIAL ORDER BY NLSSORT(NMLEITO,'NLS_SORT=BINARY_AI'), NLSSORT(NMANDAR,'NLS_SORT=BINARY_AI'), NLSSORT(NMALA,'NLS_SORT=BINARY_AI')";
  const BEDS_PRESCRIPTIONS = "SELECT DISTINCT LEITO.CDANDAR, LEITO.CDALA, LEITO.CDLEITO, LEITO.CDFILIAL, LEITO.NMLEITO, ANDAR.NMANDAR, ALA.NMALA FROM LEITO INNER JOIN ANDAR ON LEITO.CDANDAR = ANDAR.CDANDAR AND LEITO.CDFILIAL = ANDAR.CDFILIAL INNER JOIN ALA ON LEITO.CDALA = ALA.CDALA AND LEITO.CDFILIAL = ALA.CDFILIAL WHERE (LEITO.IDOCUPLEITO = 'N' OR LEITO.IDTRANSITORIO = 'S') AND LEITO.CDFILIAL = :CDFILIAL ORDER BY NLSSORT(NMANDAR,'NLS_SORT=BINARY_AI'), NLSSORT(NMALA,'NLS_SORT=BINARY_AI'), NLSSORT(NMLEITO,'NLS_SORT=BINARY_AI')";
  const BIOCHEMICAL_EVALUATION = "SELECT DISTINCT EXAME.TXFORMEXAM, EXAMREAL.CDPACIENTE, TO_CHAR(EXAMREAL.DTCONSPACI, 'DD/MM/YYYY HH24:MI:SS') AS DTCONSPACI, EXAMREAL.CDEXAME, TO_CHAR(EXAMREAL.DTREALEX, 'DD/MM/YYYY HH24:MI:SS') AS DTREALEX, EXAMREAL.IDGRAVIDEZ, EXAMREAL.NRSEMGEST, EXAMREAL.DSRECLASSI, EXAMREAL.VRRESEXA, EXAMREAL.IDRESEXA, EXAMREAL.DSLAUDO, EXAMREAL.NRSEQEXAMREA, EXAMREAL.CDFILIAL, EXAME.NMEXAME, EXAME.CDUNIDEXE FROM EXAMREAL,EXAME WHERE (EXAMREAL.CDPACIENTE = :PATIENT) AND (INSTR(:EXAMINATION,EXAMREAL.CDEXAME) <> 0 OR :EXAMINATION = 'T') AND (EXAMREAL.DTCONSPACI = TO_DATE(:APPOINTMENT_DATE,'DD/MM/YYYY HH24:MI:SS')) AND (EXAMREAL.CDFILIAL   = :UNIT) AND (EXAMREAL.CDEXAME    = EXAME.CDEXAME)";
  const DATA_TYPE_EVALUATION = "SELECT CDTIPODADO, NMTIPODADO, DSUNIDDADO FROM TIPODADO";
  const CONTROL_FEEDING = "SELECT SERVINTE.CDSERVFILI, SERVICO.IDTPSERVHOSP, SERVINTE.NRSEQUSERV, SERVINTE.IDRESTSERIN, SERVICO.NMSERVICO, TO_CHAR(SERVINTE.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, TO_CHAR(SERVINTE.DTINCLUSAO,'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO, DIETPADR.IDFORMDIET, DIETPADR.CDDIETPAD, DIETPADR.DSDIETPAD, SERVINTE.STPACIACOM FROM SERVINTE INNER JOIN DIETPADR ON DIETPADR.CDDIETPAD = SERVINTE.CDDIETPAD INNER JOIN SERVICO ON SERVICO.CDSERVFILI = SERVINTE.CDSERVFILI AND SERVICO.CDFILIAL = SERVINTE.CDFILIAL WHERE SERVINTE.CDPACIENTE =:PATIENT AND SERVINTE.CDFILIAL =:UNIT ORDER BY SERVINTE.DTSERVINTE DESC";
  const MAP_KITCHEN_MAID = "SELECT DISTINCT SERVINTE.CDFILIAL, SERVINTE.DTSERVINTE, SERVINTE.CDPACIENTE, SERVINTE.NRSEQUSERV, PACIENTE.NMPACIENTE, (PACIENTE.NMPACIENTE || ' ' || UPPER(PACIENTE.NMSOBRNOME)) AS NMINTEIRO, TO_CHAR(PACIENTE.DTNASCPACI,'DD/MM/YYYY') AS DTNASCPACI, PACIENTE.NMMAEPACIUPP, SERVINTE.CDSERVFILI, SERVICO.NMSERVICO, SERVINTE.CDDIETPAD, DIETPADR.DSDIETPAD, DIETPADR.IDFORMDIET, LEITO.CDANDAR, LEITO.CDALA, INTERNAC.CDLEITO, LEITO.NMLEITO, SERVINTE.DTHRENTREGA, SERVINTE.CDRESPENTREGA, SERVINTE.DTHRRECOLHE, SERVINTE.CDRESPRECOLHE, SERVICO.IDTPSERVHOSP, SERVINTE.STPACIACOM, SERVICO.HRINICSERV, SERVICO.HRFINASERV FROM SERVINTE INNER JOIN DIETPADR ON DIETPADR.CDDIETPAD = SERVINTE.CDDIETPAD INNER JOIN SERVICO ON SERVICO.CDSERVFILI = SERVINTE.CDSERVFILI AND SERVICO.CDFILIAL = SERVINTE.CDFILIAL INNER JOIN PACIENTE ON PACIENTE.CDPACIENTE = SERVINTE.CDPACIENTE AND PACIENTE.CDFILIAL = SERVINTE.CDFILIAL INNER JOIN INTERNAC ON INTERNAC.CDFILIAL = PACIENTE.CDFILIAL AND INTERNAC.CDPACIENTE = PACIENTE.CDPACIENTE AND INTERNAC.DTINTERNA = (SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = PACIENTE.CDPACIENTE AND CDFILIAL = PACIENTE.CDFILIAL) INNER JOIN LEITO ON LEITO.CDLEITO = INTERNAC.CDLEITO AND LEITO.CDFILIAL = INTERNAC.CDFILIAL WHERE SERVINTE.CDFILIAL = :CDFILIAL AND SERVINTE.DTSERVINTE = TRUNC(SYSDATE) AND (DTHRENTREGA IS NULL OR DTHRRECOLHE IS NULL) ORDER BY SERVICO.HRINICSERV";
  
  const DATA_EVALUATION = "SELECT CDTIPODADO, CDTBMETOAVAL FROM DADOAVAL";
  const GET_SEQUENTIAL_SERVINTE = "SELECT NRSEQUSERV FROM SERVINTE WHERE CDFILIAL = :UNIT AND CDPACIENTE =:PATIENT AND DTSERVINTE = TO_DATE(:SERVICE_DATE,'DD/MM/YYYY') AND DTINCLUSAO = TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS')";
  const GET_NVL_SEQUENTIAL_SERVINTE = "SELECT NVL(MAX(NRSEQUSERV) + 1, '01') AS NRSEQUSERV FROM SERVINTE WHERE CDFILIAL = :UNIT AND CDPACIENTE = :PATIENT AND TRUNC(DTSERVINTE) = TO_DATE( :SERVICE_DATE, 'DD/MM/YYYY')";
  const GET_SEQUENTIAL_CONFESCO = "SELECT NVL(MAX(CDSEQUCOPR) + 1, '01')+1 AS NRSEQUSERV FROM CONFESCO WHERE CDFILIAL = :UNIT AND CDPACIENTE = :PATIENT AND TRUNC(DTSERVINTE) = TO_DATE(:SERVICE_DATE,'DD/MM/YYYY')";
  const DATA_INFO_EVALUATION = "SELECT ROWNUM, DSINFOAVAL, CDTBMETOAVAL, CDPACIENTE, TO_CHAR(DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') AS DTCONSPACI, CDTIPODADO, CDFILIAL FROM INFOAVAL WHERE CDFILIAL = :UNIT AND CDPACIENTE = :PATIENT AND DTCONSPACI = TO_DATE(:APPOINTMENT_DATE,'DD/MM/YYYY HH24:MI:SS')";
  const DIETS = "SELECT CDDIETPAD, DSDIETPAD, IDFORMDIET, CDDIETGRUP FROM DIETPADR";
  const DIETS_SERVICES = "SELECT DISTINCT DIETSERV.CDDIETPAD, DIETPADR.DSDIETPAD, DIETSERV.CDFILIAL, DIETPADR.IDFORMDIET, DIETPADR.CDDIETGRUP, DIETSERV.CDSERVFILI FROM DIETSERV INNER JOIN DIETPADR ON DIETPADR.CDDIETPAD = DIETSERV.CDDIETPAD WHERE DIETSERV.CDFILIAL = :CDFILIAL";
  const DIETS_FIELDS = "SELECT DISTINCT DIETSERV.CDDIETPAD, DIETPADR.DSDIETPAD, DIETSERV.CDFILIAL FROM DIETSERV INNER JOIN DIETPADR ON DIETPADR.CDDIETPAD = DIETSERV.CDDIETPAD WHERE DIETSERV.CDFILIAL = :CDFILIAL ORDER BY DIETSERV.CDDIETPAD";
  const FORMULATION = "SELECT CDFORMULACAO, NMFORMULACAO, TRANSLATE(NMFORMULACAO,'ŠŽšžŸÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜÏÖÑÝåáçéíóúàèìòùâêîôûãõëüïöñýÿ', 'SZszYACEIOUAEIOUAEIOUAOEUIONYaaceiouaeiouaeiouaoeuionyy') AS NORMALIZEDNAME, SGFORMULACAO, CDFILAUXPRAT, CDPRODUTO, IDTIPO, CDFILIAL FROM ( SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRATO LIKE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) || '%' AND ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NOT NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT PRODUTO.CDARVPROD AS CDFORMULACAO, PRODUTO.NMPRODUTO AS NMFORMULACAO, PRODUTO.SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, PRODUTO.CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, PRSUBGRPROD, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE PRODUTO.CDPRODUTO = CDPRODESTO AND PRSUBGRPROD.CDGRUPPROD IN ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) AND ( PRSUBGRPROD.CDFILISUBGR = FI.CDFILIAL OR CDFILISUBGR = 'P' ) AND PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO AND PRODUTO.CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) UNION ALL SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT CDARVPROD AS CDFORMULACAO, NMPRODUTO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRODUTO = CDPRODESTO AND ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) ) WHERE 1 = 1 ORDER BY CDFORMULACAO";
  const ENTERAL_PLATES = "SELECT CDFORMULACAO, NMFORMULACAO, TRANSLATE(NMFORMULACAO,'ŠŽšžŸÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜÏÖÑÝåáçéíóúàèìòùâêîôûãõëüïöñýÿ', 'SZszYACEIOUAEIOUAEIOUAOEUIONYaaceiouaeiouaeiouaoeuionyy') AS NORMALIZEDNAME, SGFORMULACAO, CDFILAUXPRAT, CDPRODUTO, IDTIPO, CDFILIAL FROM ( SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRATO LIKE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) || '%' AND ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NOT NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT PRODUTO.CDARVPROD AS CDFORMULACAO, PRODUTO.NMPRODUTO AS NMFORMULACAO, PRODUTO.SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, PRODUTO.CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, PRSUBGRPROD, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE PRODUTO.CDPRODUTO = CDPRODESTO AND PRSUBGRPROD.CDGRUPPROD IN ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) AND ( PRSUBGRPROD.CDFILISUBGR = FI.CDFILIAL OR CDFILISUBGR = 'P' ) AND PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO AND PRODUTO.CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) UNION ALL SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT CDARVPROD AS CDFORMULACAO, NMPRODUTO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRODUTO = CDPRODESTO AND ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) ) WHERE IDTIPO = 'A' ORDER BY CDFORMULACAO";
  const ENTERAL_PRODUCT = "SELECT CDFORMULACAO, NMFORMULACAO, SGFORMULACAO, CDFILAUXPRAT, CDPRODUTO, IDTIPO, CDFILIAL FROM ( SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRATO LIKE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) || '%' AND ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NOT NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT PRODUTO.CDARVPROD AS CDFORMULACAO, PRODUTO.NMPRODUTO AS NMFORMULACAO, PRODUTO.SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, PRODUTO.CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, PRSUBGRPROD, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE PRODUTO.CDPRODUTO = CDPRODESTO AND PRSUBGRPROD.CDGRUPPROD IN ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) AND ( PRSUBGRPROD.CDFILISUBGR = FI.CDFILIAL OR CDFILISUBGR = 'P' ) AND PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO AND PRODUTO.CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) UNION ALL SELECT CDPRATO AS CDFORMULACAO, NMPRATO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, CDFILAUXPRAT, NULL AS CDPRODUTO, 'A' AS IDTIPO, FI.CDFILIAL FROM PRATO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE ( SELECT CDPRATOENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND ( CDFILAUXPRAT = FI.CDFILIAL OR CDFILAUXPRAT = 'P' ) AND CDNVPRATO = ( SELECT MAX(CDNVPRATO) FROM PRATO ) UNION ALL SELECT CDARVPROD AS CDFORMULACAO, NMPRODUTO AS NMFORMULACAO, SGUNIDADE AS SGFORMULACAO, NULL AS CDFILAUXPRAT, CDPRODUTO, 'F' AS IDTIPO, FI.CDFILIAL FROM PRODUTO, ( SELECT CDFILIAL FROM FILIAL WHERE CDFILIAL =:CDFILIAL ) FI WHERE CDPRODUTO = CDPRODESTO AND ( SELECT CDGRPRODENTPAR FROM PARADIETO WHERE CDFILIAL = FI.CDFILIAL ) IS NULL AND CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO) FROM PRODUTO ) ) WHERE IDTIPO = 'F' ORDER BY CDFORMULACAO";
  const EXAMINATIONS = "SELECT CDUNIDEXE, CDEXAME, NMEXAME, TXFORMEXAM FROM EXAME";
  const EATING_HABITS = "SELECT TXHABIALIM FROM DESCHABIPACI WHERE CDFILIAL = :UNITS AND CDPACIENTE = :PATIENT";
  const ENTERAL_FEEDING = "SELECT ROWNUM, CONF.CDFILIAL, CONF.CDPACIENTE, TO_CHAR(CONF.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONF.NRSEQUSERV, CONF.CDSEQUCOPR, CONF.CDFILAUXPRAT, CONF.CDPRATO, CONF.QTSERVCONF, CONF.QTPRATCONF, CONF.QTINFUCONF, CONF.HRCONSCONF, TO_CHAR(CONF.DTCONSCONF,'DD/MM/YYYY') AS DTCONSCONF, CONF.CDPRODUTO, CONF.CDVIACESDIET, CONF.IDPREPCONF, CONF.DSOBSCONF, LPAD(TRUNC(HRCONSCONF),2,'0') || LPAD(ROUND( (HRCONSCONF - TRUNC(HRCONSCONF) ) * 60),2,'0') AS HRCONF, VIA.NMVIACESDIET, PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE UNIDPRO, PRODUTO.CDARVPROD, PRATO.NMPRATO, PRATO.SGUNIDADE AS UNIDPRA, SUBSTR(' ',1,5) AS SGUNIDADE, NVL(CONF.CDPRATO,PRODUTO.CDARVPROD) AS CDFORMULACAO FROM VIACESDIET VIA, PRODUTO, PRATO, CONFESCO CONF WHERE ( CONF.CDFILIAL =:UNIT ) AND ( CONF.CDPACIENTE =:PATIENT ) AND ( VIA.CDVIACESDIET = CONF.CDVIACESDIET ) AND ( CONF.CDPRATO = PRATO.CDPRATO (+) ) AND ( CONF.CDFILAUXPRAT = PRATO.CDFILAUXPRAT (+) ) AND ( CONF.CDPRODUTO = PRODUTO.CDPRODUTO (+) ) ORDER BY CONF.DTCONSCONF DESC, CONF.HRCONSCONF DESC";
  const FIND_ENTERAL_FEEDING = "SELECT ROWNUM, CONF.CDFILIAL, CONF.CDPACIENTE, TO_CHAR(CONF.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONF.NRSEQUSERV, CONF.CDSEQUCOPR, CONF.CDFILAUXPRAT, CONF.CDPRATO, CONF.QTSERVCONF, CONF.QTPRATCONF, CONF.QTINFUCONF, CONF.HRCONSCONF, TO_CHAR(CONF.DTCONSCONF,'DD/MM/YYYY') AS DTCONSCONF, CONF.CDPRODUTO, CONF.CDVIACESDIET, CONF.IDPREPCONF, CONF.DSOBSCONF, LPAD(TRUNC(HRCONSCONF),2,'0') || LPAD(ROUND( (HRCONSCONF - TRUNC(HRCONSCONF) ) * 60),2,'0') AS HRCONF, VIA.NMVIACESDIET, PRODUTO.NMPRODUTO, PRODUTO.SGUNIDADE UNIDPRO, PRODUTO.CDARVPROD, PRATO.NMPRATO, PRATO.SGUNIDADE AS UNIDPRA, SUBSTR(' ',1,5) AS SGUNIDADE, NVL(CONF.CDPRATO,PRODUTO.CDARVPROD) AS CDFORMULACAO FROM VIACESDIET VIA, PRODUTO, PRATO, CONFESCO CONF WHERE ( CONF.CDFILIAL =:UNIT ) AND ( VIA.CDVIACESDIET = CONF.CDVIACESDIET ) AND ( CONF.CDPRATO = PRATO.CDPRATO (+) ) AND ( CONF.CDFILAUXPRAT = PRATO.CDFILAUXPRAT (+) ) AND ( CONF.CDPRODUTO = PRODUTO.CDPRODUTO (+) ) ORDER BY CONF.DTCONSCONF DESC, CONF.HRCONSCONF DESC";
  const FOOD_INTOLERANCE = "SELECT TXINTOALIM FROM DESCINTOPACI WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS";
  const HEALTH_INSURANCE = "SELECT CDSERPADDIE, NMSERPADDIE FROM PADRAOSERV ORDER BY CDSERPADDIE";
  const MEDICAL_TEAMS = "SELECT CDFILIAL, CDEQUIMED, NMEQUIMED FROM EQUIMEDI WHERE CDFILIAL = :CDFILIAL";
  const SERVICES = "SELECT IDTPSERVHOSP, IDTIPOSERV, CDSERVFILI, CDFILIAL, NMSERVICO FROM SERVICO WHERE CDFILIAL = :CDFILIAL ORDER BY CDSERVFILI";
  const ORAL_SERVICES = "SELECT DIETSERV.CDSERVFILI, DIETSERV.CDFILIAL, SERVICO.NMSERVICO, SERVICO.IDTIPOSERV, SERVICO.IDTPSERVHOSP FROM SERVICO, DIETSERV WHERE (DIETSERV.CDFILIAL = :CDFILIAL) AND (DIETSERV.CDSERVFILI IS NULL OR :TCDSERVFILI = 'T') AND (DIETSERV.CDFILIAL = SERVICO.CDFILIAL) AND (DIETSERV.CDSERVFILI = SERVICO.CDSERVFILI) AND (IDTIPOSERV IN ('A', 'D', 'N')) AND (SERVICO.IDTPSERVHOSP IS NULL OR IDTPSERVHOSP NOT IN('1', '2')) GROUP BY DIETSERV.CDSERVFILI, DIETSERV.CDFILIAL, SERVICO.NMSERVICO, SERVICO.IDTIPOSERV, SERVICO.IDTPSERVHOSP ORDER BY DIETSERV.CDSERVFILI, SERVICO.NMSERVICO";
  const LACTARY_SERVICES = "SELECT CDFILIAL, IDTPSERVHOSP, IDTIPOSERV, CDSERVFILI, NMSERVICO FROM SERVICO WHERE ( CDFILIAL =:CDFILIAL ) AND ( CDSERVFILI = NVL(NULL,CDSERVFILI) ) AND ( IDTIPOSERV = 'D' ) AND ( IDTPSERVHOSP = '2' ) ORDER BY CDSERVFILI";
  const ENTERAL_SERVICES = "SELECT CDFILIAL, IDTPSERVHOSP, IDTIPOSERV, CDSERVFILI, NMSERVICO FROM SERVICO WHERE ( CDFILIAL =:CDFILIAL ) AND ( IDTIPOSERV = 'D' ) AND ( IDTPSERVHOSP = '1' ) ORDER BY CDSERVFILI";
  const PATIENTS = "SELECT ( CASE INTERNAC.IDMOTIALTA WHEN '0' THEN NULL ELSE LEITO.CDANDAR END ) AS CDANDAR, ( CASE INTERNAC.IDMOTIALTA WHEN '0' THEN NULL ELSE LEITO.CDALA END ) AS CDALA, ( CASE INTERNAC.IDMOTIALTA WHEN '0' THEN NULL ELSE LEITO.CDLEITO END ) AS CDLEITO, ( CASE INTERNAC.IDMOTIALTA WHEN '0' THEN NULL ELSE LEITO.NMLEITO END ) AS NMLEITO, PACIENTE.DTULTATU, PACIENTE.CDFILIAL, PACIENTE.CDPACIENTE, (PACIENTE.NMPACIENTE || ' ' || UPPER(PACIENTE.NMSOBRNOME)) AS NMPACIUPPER, PACIENTE.IDSEXOPACI, TO_CHAR(PACIENTE.DTNASCPACI,'DD/MM/YYYY') AS DTNASCPACI, INTERNAC.DTALTA, ( CASE WHEN INTERNAC.IDMOTIALTA IS NULL AND LEITO.CDLEITO IS NOT NULL THEN 'INTERNADO' ELSE INTERNAC.IDMOTIALTA END ) AS IDMOTIALTA, TO_CHAR(DTINTERNA,'DD/MM/YYYY HH24:MI:SS') AS DTINTERNA, PACIENTE.CDPACIENTE || ' - ' || NMPACIUPPER AS IDNAMEPACI FROM PACIENTE LEFT JOIN INTERNAC ON INTERNAC.CDFILIAL =:CDFILIAL AND INTERNAC.CDPACIENTE = PACIENTE.CDPACIENTE AND INTERNAC.DTINTERNA = ( SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = PACIENTE.CDPACIENTE AND CDFILIAL =:CDFILIAL ) LEFT JOIN LEITO ON LEITO.CDLEITO = INTERNAC.CDLEITO AND LEITO.CDFILIAL = INTERNAC.CDFILIAL AND LEITO.CDFILIAL =:CDFILIAL WHERE PACIENTE.CDFILIAL =:CDFILIAL AND ( INTERNAC.IDMOTIALTA <> 1 OR INTERNAC.IDMOTIALTA IS NULL ) ORDER BY PACIENTE.NMPACIUPPER";
  const PROFILES = "SELECT DESCHABIPACI.CDPACIENTE, DESCHABIPACI.CDFILIAL, DESCHABIPACI.TXHABIALIM, DESCHABIPACI.DSOBSCONFID, DESCHABIPACI.DSOBSGERAL, DESCINTOPACI.TXINTOALIM FROM DESCHABIPACI LEFT JOIN DESCINTOPACI ON DESCHABIPACI.CDPACIENTE = DESCINTOPACI.CDPACIENTE WHERE DESCHABIPACI.CDFILIAL = :UNITS AND DESCHABIPACI.CDPACIENTE = :PATIENT";
  const PRESCRIPTIONS = "SELECT DISTINCT INTERNAC.CDPACIENTE, PRESDIET.CDLEITO, LEITO.NMLEITO, ANDAR.CDANDAR, ANDAR.NMANDAR, ALA.CDALA, ALA.NMALA, LEITO.CDANDAR, PRESDIET.DTPRESDIET AS DTPRESDIET, PRESDIET.CDDIETPAD, DIETPADR.DSDIETPAD, PRESDIET.DSPRESDIET DSPRESDIET, PRESDIET.DSDADOCLIN, PRESDIET.DSPRESMEDDIE, INTERNAC.CDFILIAL, PRESDIET.CDNIASNUTR, NIASSNUTRI.NMNIASNUTR FROM INTERNAC, DIETPADR, PRESDIET, NIASSNUTRI, LEITO, ANDAR, ALA WHERE ( PRESDIET.CDPACIENTE =:PATIENT ) AND ( PRESDIET.CDFILIAL =:UNITS ) AND ( INTERNAC.CDFILIAL =:UNITS ) AND ( INTERNAC.DTALTA IS NULL ) AND ( PRESDIET.CDPACIENTE = INTERNAC.CDPACIENTE ) AND ( PRESDIET.CDFILIAL = INTERNAC.CDFILIAL ) AND ( PRESDIET.CDNIASNUTR = NIASSNUTRI.CDNIASNUTR (+) ) AND ( DIETPADR.CDDIETPAD = PRESDIET.CDDIETPAD ) AND ( PRESDIET.CDFILIAL = LEITO.CDFILIAL ) AND ( PRESDIET.CDLEITO = LEITO.CDLEITO ) AND ( ANDAR.CDFILIAL = LEITO.CDFILIAL ) AND ( ANDAR.CDANDAR = LEITO.CDANDAR ) AND ( ALA.CDFILIAL = LEITO.CDFILIAL ) AND ( ALA.CDALA = LEITO.CDALA ) ORDER BY DTPRESDIET DESC";
  const NUTRITIONAL_STATUS = "SELECT CDNIASNUTR, NMNIASNUTR FROM NIASSNUTRI";
  const RESULT_EVALUATION = "SELECT RE.CDFILIAL, RE.CDTBMETOAVAL, RE.CDPACIENTE, RE.DTCONSPACI, RE.CDSEQUAVAL, RE.DSRESUAVAL, RE.DSCONTRESU, TB.NMTBMETOAVAL, TB.NRCTMETOAVAL, RE.DTINCLUSAO FROM RESUAVAL RE, TBMETOAVAL TB WHERE (RE.CDFILIAL = :CDFILIAL) AND (RE.CDPACIENTE = :CDPACIENTE) AND (RE.DTCONSPACI = TO_DATE(:DTCONSPACI,'DD/MM/YYYY HH24:MI:SS')  ) AND (TB.CDTBMETOAVAL = RE.CDTBMETOAVAL) AND (TB.CDTBMETOAVAL < '30' OR TB.CDTBMETOAVAL > '36') ORDER BY TB.IDSEQUMETO, RE.CDTBMETOAVAL, RE.CDSEQUAVAL";
  const LACTARY_FEEDING = "SELECT ROWNUM, CONF.CDFILIAL, CONF.CDPACIENTE, TO_CHAR(CONF.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONF.NRSEQUSERV, CONF.CDSEQUCOPR, CONF.CDFILAUXPRAT, CONF.CDPRATO, CONF.QTPRATCONF, CONF.HRCONSCONF, TO_CHAR(CONF.DTCONSCONF,'DD/MM/YYYY') AS DTCONSCONF, CONF.DSOBSCONF, LPAD(TRUNC(HRCONSCONF),2,'0') || LPAD(ROUND( (HRCONSCONF - TRUNC(HRCONSCONF) ) * 60),2,'0') AS HRCONF, PRATO.NMPRATO, PRATO.SGUNIDADE FROM PRATO, CONFESCO CONF WHERE ( CONF.CDFILIAL =:UNIT ) AND ( CONF.CDPACIENTE =:PATIENT ) AND ( CONF.CDPRATO = PRATO.CDPRATO ) AND ( CONF.CDFILAUXPRAT = PRATO.CDFILAUXPRAT ) ORDER BY CONF.DTCONSCONF, CONF.HRCONSCONF DESC";
  const FIND_LACTARY_FEEDING = "SELECT ROWNUM, CONF.CDFILIAL, CONF.CDPACIENTE, TO_CHAR(CONF.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONF.NRSEQUSERV, CONF.CDSEQUCOPR, CONF.CDFILAUXPRAT, CONF.CDPRATO, CONF.QTPRATCONF, CONF.HRCONSCONF, TO_CHAR(CONF.DTCONSCONF,'DD/MM/YYYY') AS DTCONSCONF, CONF.DSOBSCONF, LPAD(TRUNC(HRCONSCONF),2,'0') || LPAD(ROUND( (HRCONSCONF - TRUNC(HRCONSCONF) ) * 60),2,'0') AS HRCONF, PRATO.NMPRATO, PRATO.SGUNIDADE FROM PRATO, CONFESCO CONF WHERE ( CONF.CDFILIAL =:UNIT ) AND ( CONF.CDPRATO = PRATO.CDPRATO ) AND ( CONF.CDFILAUXPRAT = PRATO.CDFILAUXPRAT ) ORDER BY CONF.DTCONSCONF DESC, HRCONSCONF DESC";
  const NORMAL_FEEDING_NOW = "SELECT ROWNUM, DIETPADR.CDDIETPAD, DIETPADR.DSDIETPAD, COMPCARD.CDFILIAL, CARDADIA.DTCARDAPIO, COMPCARD.CDFILAUXPRAT, COMPCARD.CDPRATO, COMPCARD.CDTIPOPRAT, COMPCARD.NRORDPRATCAR, PRATO.NMPRATO, TIPOPRAT.NMTIPOPRAT, CNFCAMES.IDOPCCNFMES, CONFCARD.IDOPCCNFCARD FROM PRATO, TIPOPRAT, CNFCAMES, CARDADIA, COMPCARD, DIETPADR, DIETSERV, CONFCARD WHERE ( CARDADIA.CDFILIAL =:CDFILIAL ) AND ( COMPCARD.CDFILIAL = CARDADIA.CDFILIAL ) AND ( COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO ) AND ( PRATO.CDPRATO = COMPCARD.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = COMPCARD.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = COMPCARD.CDTIPOPRAT ) AND ( CNFCAMES.DTREFECNFMES = CARDADIA.DTMESCARD ) AND ( CNFCAMES.CDSERVFILI = CARDADIA.CDSERVFILI ) AND ( CNFCAMES.CDFILIAL = CARDADIA.CDFILIAL ) AND ( CNFCAMES.NRSEQCNFMES = COMPCARD.NRSEQPRATCAR ) AND ( CARDADIA.DTCARDAPIO BETWEEN TRUNC(SYSDATE) AND SYSDATE + 1 ) AND (DIETSERV.CDSERVFILI = CARDADIA.CDSERVFILI) AND (DIETPADR.CDDIETPAD = DIETSERV.CDDIETPAD) AND (CONFCARD.CDFILIAL = CARDADIA.CDFILIAL) AND (CONFCARD.CDSERVFILI = CARDADIA.CDSERVFILI) AND (CONFCARD.CDTIPOPRAT = TIPOPRAT.CDTIPOPRAT) ORDER BY COMPCARD.NRORDPRATCAR";
  const FOOD_INTOLERANCE_GROUP = "SELECT INT.CDFILIAL, INT.CDPACIENTE, INT.CDGRUPPROD, INT.CDSUBGRPROD, GRU.NMGRUPPROD, SUB.NMSUBGRPROD, (GRU.NMGRUPPROD || ' - ' || SUB.NMSUBGRPROD) as NMGROUPSUB FROM GRUPPROD GRU, SUBGRUPPROD SUB, INTOALIM INT WHERE (INT.CDFILIAL = :P_CDFILIAL) AND (INT.CDGRUPPROD = GRU.CDGRUPPROD) AND (INT.CDGRUPPROD = SUB.CDGRUPPROD) AND (INT.CDSUBGRPROD = SUB.CDSUBGRPROD) ORDER BY INT.CDGRUPPROD, INT.CDSUBGRPROD";
  const ALL_GROUP_SUBGROUP = "SELECT G.NMGRUPPROD, S.NMSUBGRPROD, G.CDGRUPPROD, S.CDSUBGRPROD, (G.NMGRUPPROD || ' - ' || S.NMSUBGRPROD) as NMGROUPSUB FROM GRUPPROD G LEFT JOIN SUBGRUPPROD S ON G.CDGRUPPROD = S.CDGRUPPROD ORDER BY G.NMGRUPPROD ASC";
  const NORMAL_FEEDING = "SELECT ROWNUM, CONFESCO.CDFILIAL, CONFESCO.CDPACIENTE, TO_CHAR(CONFESCO.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONFESCO.NRSEQUSERV, CONFESCO.CDSEQUCOPR, CONFESCO.IDESCOCONF, CONFESCO.DSOBSCONF, CONFESCO.CDFILAUXPRAT, CONFESCO.IDOPCAOCONF, CONFESCO.HRINTECONF, CONFESCO.HRPERICONF, CONFESCO.HRCONSCONF, CONFESCO.DTCONSCONF, CONFESCO.IDRESTCONF, CONFESCO.QTPRATCONF, PRATO.CDPRATO, TIPOPRAT.CDTIPOPRAT, TIPOPRAT.NMTIPOPRAT, PRATO.NMPRATO, SERVINTE.CDDIETPAD, CONFCARD.IDOPCCNFCARD FROM TIPOPRAT, PRATO, CONFESCO, SERVINTE, CONFCARD WHERE ( CONFESCO.CDFILIAL =:UNIT ) AND ( CONFESCO.CDPACIENTE =:PATIENT ) AND ( CONFESCO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( CONFESCO.CDPACIENTE = SERVINTE.CDPACIENTE ) AND ( CONFESCO.DTSERVINTE = SERVINTE.DTSERVINTE ) AND ( CONFESCO.NRSEQUSERV = SERVINTE.NRSEQUSERV ) AND ( PRATO.CDPRATO = CONFESCO.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = CONFESCO.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = CONFESCO.CDTIPOPRAT ) AND (CONFCARD.CDFILIAL = SERVINTE.CDFILIAL) AND (CONFCARD.CDSERVFILI = SERVINTE.CDSERVFILI) AND (CONFCARD.CDTIPOPRAT = TIPOPRAT.CDTIPOPRAT) ORDER BY CONFESCO.DTCONSCONF, CONFESCO.HRCONSCONF, CONFESCO.CDSEQUCOPR";
  const GET_NORMAL_FEEDING = "SELECT ROWNUM, CONFESCO.CDFILIAL, CONFESCO.CDPACIENTE, TO_CHAR(CONFESCO.DTSERVINTE,'DD/MM/YYYY HH24:MI:SS') AS DTSERVINTE, CONFESCO.NRSEQUSERV, CONFESCO.CDSEQUCOPR, CONFESCO.IDESCOCONF, CONFESCO.DSOBSCONF, CONFESCO.CDFILAUXPRAT, CONFESCO.IDOPCAOCONF, CONFESCO.HRINTECONF, CONFESCO.HRPERICONF, CONFESCO.HRCONSCONF, CONFESCO.DTCONSCONF, CONFESCO.IDRESTCONF, CONFESCO.QTPRATCONF, PRATO.CDPRATO, TIPOPRAT.CDTIPOPRAT, TIPOPRAT.NMTIPOPRAT, PRATO.NMPRATO, SERVINTE.CDDIETPAD FROM TIPOPRAT, PRATO, CONFESCO, SERVINTE WHERE (CONFESCO.CDFILIAL = :UNIT) AND (CONFESCO.CDPACIENTE = :PATIENT) AND (CONFESCO.CDFILIAL = SERVINTE.CDFILIAL) AND (CONFESCO.CDPACIENTE = SERVINTE.CDPACIENTE) AND (CONFESCO.DTSERVINTE = SERVINTE.DTSERVINTE) AND (CONFESCO.NRSEQUSERV = SERVINTE.NRSEQUSERV) AND (PRATO.CDPRATO       = CONFESCO.CDPRATO) AND (PRATO.CDFILAUXPRAT  = CONFESCO.CDFILAUXPRAT) AND (TIPOPRAT.CDTIPOPRAT = CONFESCO.CDTIPOPRAT) AND (CONFESCO.DTSERVINTE = :DTSERVINTE) ORDER BY CONFESCO.DTCONSCONF, CONFESCO.HRCONSCONF, CONFESCO.CDSEQUCOPR";
  const FIND_NORMAL_FEEDINGS = "SELECT ROWNUM, CONFESCO.CDFILIAL, CONFESCO.CDPACIENTE, TO_CHAR(CONFESCO.DTSERVINTE,'DD/MM/YYYY') AS DTSERVINTE, CONFESCO.NRSEQUSERV, CONFESCO.CDSEQUCOPR, CONFESCO.IDESCOCONF, CONFESCO.DSOBSCONF, CONFESCO.CDFILAUXPRAT, CONFESCO.IDOPCAOCONF, CONFESCO.HRINTECONF, CONFESCO.HRPERICONF, CONFESCO.HRCONSCONF, CONFESCO.DTCONSCONF, CONFESCO.IDRESTCONF, CONFESCO.QTPRATCONF, PRATO.CDPRATO, TIPOPRAT.CDTIPOPRAT, TIPOPRAT.NMTIPOPRAT, PRATO.NMPRATO, SERVINTE.CDDIETPAD FROM TIPOPRAT, PRATO, CONFESCO, SERVINTE WHERE ( CONFESCO.CDFILIAL =:UNIT ) AND ( CONFESCO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( CONFESCO.CDPACIENTE = SERVINTE.CDPACIENTE ) AND ( CONFESCO.DTSERVINTE = SERVINTE.DTSERVINTE ) AND ( CONFESCO.NRSEQUSERV = SERVINTE.NRSEQUSERV ) AND ( PRATO.CDPRATO = CONFESCO.CDPRATO ) AND ( PRATO.CDFILAUXPRAT = CONFESCO.CDFILAUXPRAT ) AND ( TIPOPRAT.CDTIPOPRAT = CONFESCO.CDTIPOPRAT ) ORDER BY CONFESCO.DTCONSCONF, CONFESCO.HRCONSCONF, CONFESCO.CDSEQUCOPR";
  const GET_COUNT_PATIENT_CODE = "SELECT MAX(CASE WHEN  NOT REGEXP_LIKE(CDPACIENTE, '[A-Za-z]', 'i') THEN CDPACIENTE ELSE '0' END) + 1 AS COUNT_PATIENT_CODE FROM (SELECT CDPACIENTE FROM PACIENTE WHERE CDFILIAL = :CDFILIAL)";
  const IS_SEQUENTIAL_AJUSTA = "SELECT IDCTRLCDPACI, IDAJUSTAPACI FROM PARADIETO WHERE CDFILIAL = :CDFILIAL";
  const GET_RESTINT_BY_PLATE = "SELECT DISTINCT INT.CDPACIENTE, SUB.NMSUBGRPROD, 'I' AS IDINTREST, '' AS NMDIAGNOST FROM PRSUBGRPROD PRO, SUBGRUPPROD SUB, INTOALIM INT, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P') AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) ) PRODUTO WHERE (INT.CDFILIAL = :CDFILIAL) AND (INT.CDPACIENTE = :CDPACIENTE) AND (PRO.CDFILISUBGR = :CDFILIAL OR PRO.CDFILISUBGR = 'P') AND (INT.CDGRUPPROD = PRO.CDGRUPPROD) AND (INT.CDSUBGRPROD = PRO.CDSUBGRPROD) AND (PRODUTO.CDPRODUTO = PRO.CDPRODUTO) AND (SUB.CDGRUPPROD = PRO.CDGRUPPROD) AND (SUB.CDSUBGRPROD = PRO.CDSUBGRPROD) UNION ALL SELECT CDPACIENTE, SUB.NMSUBGRPROD, 'R' AS IDINTREST, DIAGNOST.NMDIAGNOST FROM DIAGINTER, PRSUBGRPROD PRO, SUBGRUPPROD SUB, DIAGNOST, RESTDIAG, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P') AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) ) PRODUTO, PARAMGERAL WHERE(DIAGINTER.CDFILIAL = :CDFILIAL) AND (DIAGINTER.CDPACIENTE = :CDPACIENTE) AND (DIAGINTER.DTINTERNA = :DTINTERNA) AND (DIAGINTER.CDTABECDI = PARAMGERAL.CDTABECDIPA) AND (PRO.CDFILISUBGR = :CDFILIAL OR PRO.CDFILISUBGR = 'P') AND (DIAGINTER.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGINTER.CDDIAGNOST = RESTDIAG.CDDIAGNOST) AND (RESTDIAG.CDGRUPPROD = PRO.CDGRUPPROD) AND (RESTDIAG.CDSUBGRPROD = PRO.CDSUBGRPROD) AND (PRODUTO.CDPRODUTO = PRO.CDPRODUTO) AND (SUB.CDGRUPPROD = PRO.CDGRUPPROD) AND (SUB.CDSUBGRPROD = PRO.CDSUBGRPROD) AND (DIAGNOST.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGNOST.CDDIAGNOST = RESTDIAG.CDDIAGNOST) UNION ALL SELECT CDPACIENTE, SUB.NMSUBGRPROD, 'R' AS IDINTREST, DIAGNOST.NMDIAGNOST FROM DIAGPACI, PRSUBGRPROD PRO, SUBGRUPPROD SUB, DIAGNOST, RESTDIAG, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P') AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT OR CDFILAUXPRAT = 'P')AND (CDPRATO LIKE :CDPRATO ||'%') AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) ) PRODUTO, PARAMGERAL WHERE(DIAGPACI.CDFILIAL = :CDFILIAL) AND (DIAGPACI.CDPACIENTE = :CDPACIENTE) AND (DIAGPACI.DTCONSPACI >= :DTINTERNA) AND (DIAGPACI.CDTABECDI = PARAMGERAL.CDTABECDIPA) AND (PRO.CDFILISUBGR = :CDFILIAL OR PRO.CDFILISUBGR = 'P') AND (DIAGPACI.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGPACI.CDDIAGNOST = RESTDIAG.CDDIAGNOST) AND (RESTDIAG.CDGRUPPROD = PRO.CDGRUPPROD) AND (RESTDIAG.CDSUBGRPROD = PRO.CDSUBGRPROD) AND (PRODUTO.CDPRODUTO = PRO.CDPRODUTO) AND (SUB.CDGRUPPROD = PRO.CDGRUPPROD) AND (SUB.CDSUBGRPROD = PRO.CDSUBGRPROD) AND (DIAGNOST.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGNOST.CDDIAGNOST = RESTDIAG.CDDIAGNOST)";
  const VERIFY_RESTRICTION = "SELECT PRSUBGRPROD.CDPRODUTO FROM DIAGINTER, PRSUBGRPROD, RESTDIAG, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT) AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) ) PRODUTO, PARAMGERAL WHERE(DIAGINTER.CDFILIAL = :CDFILIAL) AND (DIAGINTER.CDPACIENTE = :CDPACIENTE) AND (DIAGINTER.DTINTERNA = :DTINTERNA) AND (DIAGINTER.CDTABECDI = PARAMGERAL.CDTABECDIPA) AND (PRSUBGRPROD.CDFILISUBGR = :CDFILIAL OR PRSUBGRPROD.CDFILISUBGR = 'P') AND (DIAGINTER.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGINTER.CDDIAGNOST = RESTDIAG.CDDIAGNOST) AND (RESTDIAG.CDGRUPPROD = PRSUBGRPROD.CDGRUPPROD) AND (RESTDIAG.CDSUBGRPROD = PRSUBGRPROD.CDSUBGRPROD) AND (PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO) UNION ALL SELECT PRSUBGRPROD.CDPRODUTO FROM DIAGPACI, PRSUBGRPROD, RESTDIAG, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT) AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO ) AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) ) PRODUTO, PARAMGERAL WHERE(DIAGPACI.CDFILIAL = :CDFILIAL) AND (DIAGPACI.CDPACIENTE = :CDPACIENTE) AND (DIAGPACI.DTCONSPACI >= :DTINTERNA) AND (DIAGPACI.CDTABECDI = PARAMGERAL.CDTABECDIPA) AND (PRSUBGRPROD.CDFILISUBGR = :CDFILIAL OR PRSUBGRPROD.CDFILISUBGR = 'P') AND (DIAGPACI.CDTABECDI = RESTDIAG.CDTABECDI) AND (DIAGPACI.CDDIAGNOST = RESTDIAG.CDDIAGNOST) AND (RESTDIAG.CDGRUPPROD = PRSUBGRPROD.CDGRUPPROD) AND (RESTDIAG.CDSUBGRPROD = PRSUBGRPROD.CDSUBGRPROD) AND (PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO) UNION ALL SELECT PRATO.CDPRODUTO FROM MEDICAPACI MEDPACI, PRINATIVMEDI PRIMED, PRINATIVNUTR PRINUT, NUTRIENTE, NUTRPROD, (SELECT CDPRODUTO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT) AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) UNION ALL SELECT CDPRODUTO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT) AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT )AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) ) UNION ALL SELECT CDPRODUTO FROM RECEPADR WHERE (CDFILAUXPRAT = :CDFILAUXPRAT) AND (CDPRATO = :CDPRATO) AND NOT EXISTS (SELECT CDPRATO FROM RECEFILI WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) ) AND NOT EXISTS (SELECT CDPRATO FROM RECESERV WHERE (CDFILAUXPRAT = :CDFILAUXPRAT)AND (CDPRATO = :CDPRATO) AND (CDFILIAL = :CDFILIAL) AND (CDSERVFILI = :CDSERVFILI) )) PRATO WHERE (MEDPACI.CDFILIAL = :CDFILIAL) AND (MEDPACI.CDPACIENTE = :CDPACIENTE) AND (MEDPACI.CDMEDICAMENT = PRIMED.CDMEDICAMENT) AND (:DTCARDAPIO BETWEEN MEDPACI.DTINIUSOMEDI AND MEDPACI.DTFINUSOMEDI) AND (PRIMED.CDPRINATIV = PRINUT.CDPRINATIV) AND (NUTRIENTE.CDNUTRIENTE = PRINUT.CDNUTRIENTE) AND (PRINUT.IDABPRATNUTR = '1') AND (NUTRPROD.CDNUTRIENTE = PRINUT.CDNUTRIENTE) AND (NUTRPROD.CDPRODUTO = PRATO.CDPRODUTO)";
  const GET_PLATES_RESINT = "SELECT CONF.CDPACIENTE, CONF.CDFILIAL, CONF.CDPRATO, CONF.CDTIPOPRAT, CONF.CDFILAUXPRAT, CONF.NRSEQUSERV, SERVINTE.CDSERVFILI, SERVINTE.DTINTERNA, TO_CHAR(SERVINTE.DTSERVINTE, 'DD/MM/YYYY') AS DTSERVINTE FROM CONFESCO CONF LEFT JOIN SERVINTE ON CONF.NRSEQUSERV = SERVINTE.NRSEQUSERV AND CONF.CDPACIENTE = SERVINTE.CDPACIENTE AND CONF.DTSERVINTE = SERVINTE.DTSERVINTE WHERE (CONF.CDFILIAL = :CDFILIAL) AND (CONF.IDRESTCONF = '1')";
  const HALLS = "SELECT DISTINCT CDANDAR, ALA.CDALA, ALA.CDFILIAL, ALA.NMALA FROM ALA JOIN ALANDAR ON ALA.CDALA = ALANDAR.CDALA WHERE ALA.CDFILIAL =:CDFILIAL";
  const HALLS_DISTINCT = "SELECT DISTINCT NULL AS CDANDAR, ALA.CDALA, ALA.CDFILIAL, ALA.NMALA FROM ALA WHERE ALA.CDFILIAL =:CDFILIAL";
  const STOREYS = "SELECT DISTINCT ANDAR.CDANDAR, ANDAR.NMANDAR, ANDAR.CDFILIAL FROM ANDAR WHERE CDFILIAL = :CDFILIAL ORDER BY NLSSORT(CDANDAR,'NLS_SORT=BINARY_AI')";
  const NUTRITIONIST_BEDS = "SELECT LEITO.CDANDAR, ALA.NMALA, ALA.CDALA, ANDAR.NMANDAR, LEITO.CDFILIAL, LEITO.CDLEITO, LEITO.NMLEITO FROM LEITO JOIN ALA ON ALA.CDALA = LEITO.CDALA AND LEITO.CDFILIAL =:CDFILIAL JOIN NUTRICIOALANDAR ON ALA.CDALA = NUTRICIOALANDAR.CDALA AND ALA.CDFILIAL =:CDFILIAL JOIN ANDAR ON NUTRICIOALANDAR.CDANDAR = ANDAR.CDANDAR AND ANDAR.CDFILIAL =: CDFILIAL AND LEITO.CDANDAR = ANDAR.CDANDAR WHERE NUTRICIOALANDAR.CDNUTRICIO =:CDNUTRICIO";
  const NUTRITIONIST_BEDS_PRESCRIPTIONS = "SELECT LEITO.CDANDAR, ALA.NMALA, ALA.CDALA, ANDAR.NMANDAR, LEITO.CDFILIAL, LEITO.CDLEITO, LEITO.NMLEITO FROM LEITO JOIN ALA ON ALA.CDALA = LEITO.CDALA AND LEITO.CDFILIAL =:CDFILIAL JOIN NUTRICIOALANDAR ON ALA.CDALA = NUTRICIOALANDAR.CDALA AND ALA.CDFILIAL =:CDFILIAL JOIN ANDAR ON NUTRICIOALANDAR.CDANDAR = ANDAR.CDANDAR AND ANDAR.CDFILIAL =: CDFILIAL AND LEITO.CDANDAR = ANDAR.CDANDAR WHERE NUTRICIOALANDAR.CDNUTRICIO =:CDNUTRICIO AND (LEITO.IDOCUPLEITO = 'N' OR LEITO.IDTRANSITORIO = 'S')";
  const NUTRITIONIST_HALLS_DISTINCT = "SELECT NULL AS CDANDAR, ALA.NMALA, ALA.CDALA, ALA.CDFILIAL FROM ANDAR JOIN NUTRICIOALANDAR ON ANDAR.CDANDAR = NUTRICIOALANDAR.CDANDAR AND ANDAR.CDFILIAL =:CDFILIAL JOIN ALA ON ALA.CDALA = NUTRICIOALANDAR.CDALA AND ALA.CDFILIAL =:CDFILIAL WHERE NUTRICIOALANDAR.CDNUTRICIO =:CDNUTRICIO GROUP BY ALA.CDALA, ALA.NMALA, ALA.CDFILIAL";
  const NUTRITIONIST_HALLS = "SELECT ANDAR.CDANDAR, ALA.NMALA, ALA.CDALA, ALA.CDFILIAL FROM ANDAR JOIN NUTRICIOALANDAR ON ANDAR.CDANDAR = NUTRICIOALANDAR.CDANDAR AND ANDAR.CDFILIAL =: CDFILIAL JOIN ALA ON ALA.CDALA = NUTRICIOALANDAR.CDALA AND ALA.CDFILIAL =: CDFILIAL WHERE NUTRICIOALANDAR.CDNUTRICIO =: CDNUTRICIO";
  const NUTRITIONIST_STOREYS = "SELECT DISTINCT ANDAR.CDANDAR, ANDAR.NMANDAR, ANDAR.CDFILIAL FROM ANDAR JOIN NUTRICIOALANDAR ON ANDAR.CDANDAR = NUTRICIOALANDAR.CDANDAR AND NUTRICIOALANDAR.CDFILIAL =: CDFILIAL WHERE NUTRICIOALANDAR.CDNUTRICIO =: CDNUTRICIO";
  const NUTRITIONIST_PATIENTS = "SELECT * FROM ( SELECT NUTRICIOALANDAR.CDNUTRICIO, DECODE(INTERNAC.IDMOTIALTA,'0',NULL,LEITO.CDANDAR) AS CDANDAR, DECODE(INTERNAC.IDMOTIALTA,'0',NULL,LEITO.CDALA) AS CDALA, DECODE(INTERNAC.IDMOTIALTA,'0',NULL,LEITO.CDLEITO) AS CDLEITO, DECODE(INTERNAC.IDMOTIALTA,'0',NULL,LEITO.NMLEITO) AS NMLEITO, PACIENTE.DTULTATU, PACIENTE.CDFILIAL, PACIENTE.CDPACIENTE, PACIENTE.NMPACIUPPER AS NMPACIUPPER, PACIENTE.IDSEXOPACI, TO_CHAR(PACIENTE.DTNASCPACI,'DD/MM/YYYY') AS DTNASCPACI, INTERNAC.DTALTA, ( CASE WHEN INTERNAC.IDMOTIALTA IS NULL AND LEITO.CDLEITO IS NOT NULL THEN 'INTERNADO' ELSE INTERNAC.IDMOTIALTA END ) AS IDMOTIALTA, TO_CHAR(DTINTERNA,'DD/MM/YYYY HH24:MI:SS') AS DTINTERNA, PACIENTE.CDPACIENTE || ' - ' || PACIENTE.NMPACIUPPER AS IDNAMEPACI FROM PACIENTE LEFT JOIN INTERNAC ON INTERNAC.CDFILIAL =:CDFILIAL AND INTERNAC.CDPACIENTE = PACIENTE.CDPACIENTE AND INTERNAC.DTINTERNA = ( SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = PACIENTE.CDPACIENTE AND CDFILIAL =:CDFILIAL ) LEFT JOIN LEITO ON LEITO.CDLEITO = INTERNAC.CDLEITO AND LEITO.CDFILIAL = INTERNAC.CDFILIAL AND LEITO.CDFILIAL =:CDFILIAL LEFT JOIN NUTRICIOALANDAR ON NUTRICIOALANDAR.CDFILIAL = PACIENTE.CDFILIAL AND LEITO.CDALA = NUTRICIOALANDAR.CDALA AND LEITO.CDANDAR = NUTRICIOALANDAR.CDANDAR WHERE PACIENTE.CDFILIAL =:CDFILIAL AND ( INTERNAC.IDMOTIALTA <> 1 OR INTERNAC.IDMOTIALTA IS NULL ) ORDER BY PACIENTE.NMPACIUPPER ) WHERE ( CDANDAR IN ( SELECT CDANDAR FROM NUTRICIOALANDAR WHERE CDNUTRICIO =:CDNUTRICIO ) AND CDALA IN ( SELECT CDALA FROM NUTRICIOALANDAR WHERE CDNUTRICIO =:CDNUTRICIO AND NUTRICIOALANDAR.CDANDAR = CDANDAR ) AND CDNUTRICIO = :CDNUTRICIO ) OR ( CDLEITO IS NULL AND (CDNUTRICIO = :CDNUTRICIO OR CDNUTRICIO IS NULL))";
  const HAS_NUTRITIONIST_PARAMS = "SELECT * FROM NUTRICIOALANDAR WHERE CDNUTRICIO =: CDNUTRICIO AND CDFILIAL =: CDFILIAL";
  const GET_NUTRICIO = "SELECT CDFILIAL, CDNUTRICIO, NRCRNNUTRICI, IDATIVO FROM NUTRICIO WHERE CDFILIAL = :CDFILIAL AND CDNUTRICIO = :CDOPERADOR";
  const MP_TOT_PRATOSERV = "SELECT LISTAGG(NMPRATO || DSOBSCONF || NMSUBGRPROD, ', ') WITHIN GROUP( ORDER BY A.CDFILIAL, DTSERVINTE, CDANDAR, CDALA, CDLEITO, CDPACIENTE, CDSERVFILI, CDDIETPAD ) AS PONTOENTREGA, A.CDFILIAL, DTSERVINTE, CDANDAR, CDALA, CDLEITO, CDPACIENTE, CDSERVFILI, CDDIETPAD FROM ( SELECT SERVINTE.CDFILIAL, SERVINTE.CDSERVFILI, SERVINTE.CDDIETPAD, INTERNAC.CDLEITO, PACIENTE.CDPACIENTE, DECODE(NVL(CONFESCO.DSOBSCONF, ''), '', '', ' (<obsPrat>: ' || CONFESCO.DSOBSCONF || ')')    AS DSOBSCONF, SERVINTE.DTSERVINTE, SUBGRUPPROD.CDSUBGRPROD, DECODE(NVL(SUBGRUPPROD.NMSUBGRPROD, ''), '', '', ' <restAlim>**' || SUBGRUPPROD.NMSUBGRPROD || '**</restAlim>') AS NMSUBGRPROD, LEITO.CDANDAR, LEITO.CDALA, CONFESCO.CDPRATO, CONFESCO.CDFILAUXPRAT FROM SERVINTE, PACIENTE, CONFESCO, SUBGRUPPROD, LEITO, INTERNAC, ( SELECT IT.CDGRUPPROD, IT.CDSUBGRPROD, SUB.NMSUBGRPROD, SV.CDPACIENTE, SV.DTSERVINTE, CF.CDPRODUTO FROM CONFESCO    CF, SERVINTE    SV, PRSUBGRPROD PRO, INTOALIM    IT, SUBGRUPPROD SUB WHERE ( SV.DTSERVINTE = :P_DATA ) AND ( SV.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SV.CDSERVFILI) <> 0 ) ) AND ( SV.CDPACIENTE = CF.CDPACIENTE ) AND ( SV.DTSERVINTE = CF.DTSERVINTE ) AND ( SV.NRSEQUSERV = CF.NRSEQUSERV ) AND ( SV.STPACIACOM <> '1' ) AND ( IT.CDPACIENTE = SV.CDPACIENTE ) AND ( IT.CDFILIAL = SV.CDFILIAL ) AND ( CF.CDPRODUTO = PRO.CDPRODUTO ) AND ( CF.CDFILIAL = SV.CDFILIAL ) AND ( PRO.CDGRUPPROD = IT.CDGRUPPROD ) AND ( PRO.CDSUBGRPROD = IT.CDSUBGRPROD ) AND ( SUB.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( SUB.CDSUBGRPROD = PRO.CDSUBGRPROD ) ) PRODINT, ( SELECT DISTINCT CDGRUPPROD, CDSUBGRPROD, NMSUBGRPROD, CDPACIENTE, DTSERVINTE, CDPRATO, CDFILAUXPRAT FROM ( SELECT IT.CDGRUPPROD, IT.CDSUBGRPROD, SUB.NMSUBGRPROD, SV.CDPACIENTE, SV.DTSERVINTE, CF.CDPRATO, CF.CDFILAUXPRAT /*,CF.CDPRODUTO*/ FROM RECESERV    RS, CONFESCO    CF, SERVINTE    SV, PRSUBGRPROD PRO, INTOALIM    IT, SUBGRUPPROD SUB WHERE ( SV.DTSERVINTE = :P_DATA ) AND ( SV.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SV.CDSERVFILI) <> 0 ) ) AND ( SV.CDPACIENTE = CF.CDPACIENTE ) AND ( SV.DTSERVINTE = CF.DTSERVINTE ) AND ( SV.NRSEQUSERV = CF.NRSEQUSERV ) AND ( SV.STPACIACOM <> '1' ) AND ( RS.CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( RS.CDPRATO = CF.CDPRATO ) AND ( RS.CDFILIAL = SV.CDFILIAL ) AND ( RS.CDSERVFILI = SV.CDSERVFILI ) AND ( CF.CDFILIAL = SV.CDFILIAL ) AND ( IT.CDPACIENTE = SV.CDPACIENTE ) AND ( IT.CDFILIAL = SV.CDFILIAL ) AND ( PRO.CDGRUPPROD = IT.CDGRUPPROD ) AND ( PRO.CDSUBGRPROD = IT.CDSUBGRPROD ) AND ( SUB.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( SUB.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RS.CDPRODUTO = PRO.CDPRODUTO ) UNION ALL SELECT IT.CDGRUPPROD, IT.CDSUBGRPROD, SUB.NMSUBGRPROD, SV.CDPACIENTE, SV.DTSERVINTE, CF.CDPRATO, CF.CDFILAUXPRAT /*,CF.CDPRODUTO*/ FROM RECEFILI    RF, CONFESCO    CF, SERVINTE    SV, PRSUBGRPROD PRO, INTOALIM    IT, SUBGRUPPROD SUB WHERE ( SV.DTSERVINTE = :P_DATA ) AND ( SV.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SV.CDSERVFILI) <> 0 ) ) AND ( SV.CDPACIENTE = CF.CDPACIENTE ) AND ( SV.DTSERVINTE = CF.DTSERVINTE ) AND ( SV.NRSEQUSERV = CF.NRSEQUSERV ) AND ( SV.STPACIACOM <> '1' ) AND ( RF.CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( RF.CDPRATO = CF.CDPRATO ) AND ( RF.CDFILIAL = SV.CDFILIAL ) AND ( CF.CDFILIAL = SV.CDFILIAL ) AND ( IT.CDPACIENTE = SV.CDPACIENTE ) AND ( IT.CDFILIAL = SV.CDFILIAL ) AND ( PRO.CDGRUPPROD = IT.CDGRUPPROD ) AND ( PRO.CDSUBGRPROD = IT.CDSUBGRPROD ) AND ( SUB.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( SUB.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RF.CDPRODUTO = PRO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRATO FROM RECESERV WHERE ( CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( CDPRATO = CF.CDPRATO ) AND ( CDFILIAL = SV.CDFILIAL ) AND ( CDSERVFILI = SV.CDSERVFILI ) ) UNION ALL SELECT IT.CDGRUPPROD, IT.CDSUBGRPROD, SUB.NMSUBGRPROD, SV.CDPACIENTE, SV.DTSERVINTE, CF.CDPRATO, CF.CDFILAUXPRAT /*,CF.CDPRODUTO*/ FROM RECEPADR    RP, CONFESCO    CF, SERVINTE    SV, PRSUBGRPROD PRO, INTOALIM    IT, SUBGRUPPROD SUB WHERE ( SV.DTSERVINTE = :P_DATA ) AND ( SV.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SV.CDSERVFILI) <> 0 ) ) AND ( SV.CDPACIENTE = CF.CDPACIENTE ) AND ( SV.DTSERVINTE = CF.DTSERVINTE ) AND ( SV.NRSEQUSERV = CF.NRSEQUSERV ) AND ( SV.STPACIACOM <> '1' ) AND ( RP.CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( RP.CDPRATO = CF.CDPRATO ) AND ( CF.CDFILIAL = SV.CDFILIAL ) AND ( IT.CDPACIENTE = SV.CDPACIENTE ) AND ( IT.CDFILIAL = SV.CDFILIAL ) AND ( PRO.CDGRUPPROD = IT.CDGRUPPROD ) AND ( PRO.CDSUBGRPROD = IT.CDSUBGRPROD ) AND ( SUB.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( SUB.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RP.CDPRODUTO = PRO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRATO FROM RECEFILI WHERE ( CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( CDPRATO = CF.CDPRATO ) AND ( CDFILIAL = SV.CDFILIAL ) ) AND NOT EXISTS ( SELECT CDPRATO FROM RECESERV WHERE ( CDFILAUXPRAT = CF.CDFILAUXPRAT ) AND ( CDPRATO = CF.CDPRATO ) AND ( CDFILIAL = SV.CDFILIAL ) AND ( CDSERVFILI = SV.CDSERVFILI ) ) ) ) INT WHERE ( SERVINTE.DTSERVINTE = :P_DATA ) AND ( SERVINTE.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SERVINTE.CDSERVFILI) <> 0 ) ) AND ( :P_CDALA IS NULL OR :P_CDALA = LEITO.CDALA ) AND ( :P_CDANDAR IS NULL OR :P_CDANDAR = LEITO.CDANDAR ) AND ( :P_CDPACIENTE IS NULL OR SERVINTE.CDPACIENTE = :P_CDPACIENTE ) AND ( INTERNAC.CDPACIENTE = SERVINTE.CDPACIENTE ) AND ( INTERNAC.CDLEITO = LEITO.CDLEITO ) AND ( INTERNAC.DTINTERNA = SERVINTE.DTINTERNA ) AND ( INTERNAC.CDFILIAL = SERVINTE.CDFILIAL ) AND ( SERVINTE.CDPACIENTE = CONFESCO.CDPACIENTE (+) ) AND ( SERVINTE.DTSERVINTE = CONFESCO.DTSERVINTE (+) ) AND ( SERVINTE.NRSEQUSERV = CONFESCO.NRSEQUSERV (+) ) AND ( SERVINTE.CDFILIAL = CONFESCO.CDFILIAL (+) ) AND ( SERVINTE.STPACIACOM <> '1' ) AND ( LEITO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( CONFESCO.CDPACIENTE = INT.CDPACIENTE (+) ) AND ( CONFESCO.DTSERVINTE = INT.DTSERVINTE (+) ) AND ( CONFESCO.CDPRATO = INT.CDPRATO (+) ) AND ( CONFESCO.CDFILAUXPRAT = INT.CDFILAUXPRAT (+) ) AND ( CONFESCO.CDPACIENTE = PRODINT.CDPACIENTE (+) ) AND ( CONFESCO.DTSERVINTE = PRODINT.DTSERVINTE (+) ) AND ( CONFESCO.CDPRODUTO = PRODINT.CDPRODUTO (+) ) AND ( INT.CDSUBGRPROD = SUBGRUPPROD.CDSUBGRPROD (+) ) AND ( INT.CDGRUPPROD = SUBGRUPPROD.CDGRUPPROD (+) ) AND ( SERVINTE.CDPACIENTE = PACIENTE.CDPACIENTE ) AND ( SERVINTE.CDFILIAL = PACIENTE.CDFILIAL ) UNION ALL SELECT SERVINTE.CDFILIAL, SERVINTE.CDSERVFILI, SERVINTE.CDDIETPAD, INTERNAC.CDLEITO, PACIENTE.CDPACIENTE, '' AS DSOBSCONF, SERVINTE.DTSERVINTE, SUBGRUPPROD.CDSUBGRPROD, SUBGRUPPROD.NMSUBGRPROD, LEITO.CDANDAR, LEITO.CDALA, '' AS CDPRATO, '' AS CDFILAUXPRAT FROM SERVINTE, LEITO, INTERNAC, PACIENTE, DIAGINTER, SUBGRUPPROD, ( SELECT DP.CDGRUPPROD, DP.CDSUBGRPROD, DP.CDDIAGNOST FROM PRSUBGRPROD PRO, PRODUTO     CP, RESTDIAG    DP WHERE ( DP.CDTABECDI = :P_CDTABECID ) AND ( DP.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( DP.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( CP.CDPRODUTO = PRO.CDPRODUTO ) UNION ALL SELECT DP.CDGRUPPROD, DP.CDSUBGRPROD, DP.CDDIAGNOST FROM RECESERV    RS, PRSUBGRPROD PRO, RESTDIAG    DP WHERE ( RS.CDFILIAL = :P_CDFILIAL ) AND ( NVL(:P_CDSERVFILI, RS.CDSERVFILI) = RS.CDSERVFILI ) AND ( DP.CDTABECDI = :P_CDTABECID ) AND ( DP.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( DP.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RS.CDPRODUTO = PRO.CDPRODUTO ) UNION ALL SELECT DP.CDGRUPPROD, DP.CDSUBGRPROD, DP.CDDIAGNOST FROM RECEFILI    RF, PRSUBGRPROD PRO, RESTDIAG    DP WHERE ( RF.CDFILIAL = :P_CDFILIAL ) AND ( DP.CDTABECDI = :P_CDTABECID ) AND ( DP.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( DP.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RF.CDPRODUTO = PRO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRATO FROM RECESERV WHERE ( CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, CDSERVFILI) <> 0 ) ) ) UNION ALL SELECT DP.CDGRUPPROD, DP.CDSUBGRPROD, DP.CDDIAGNOST FROM RECEPADR    RP, PRSUBGRPROD PRO, RESTDIAG    DP WHERE ( DP.CDTABECDI = :P_CDTABECID ) AND ( DP.CDGRUPPROD = PRO.CDGRUPPROD ) AND ( DP.CDSUBGRPROD = PRO.CDSUBGRPROD ) AND ( RP.CDPRODUTO = PRO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRATO FROM RECEFILI WHERE ( CDFILIAL = :P_CDFILIAL ) ) AND NOT EXISTS ( SELECT CDPRATO FROM RECESERV WHERE ( CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, CDSERVFILI) <> 0 ) ) ) ) DIAG WHERE ( SERVINTE.DTSERVINTE = :P_DATA ) AND ( SERVINTE.CDFILIAL = :P_CDFILIAL ) AND ( :P_CDSERVFILI IS NULL OR ( INSTR(:P_CDSERVFILI, SERVINTE.CDSERVFILI) <> 0 ) ) AND ( :P_CDALA IS NULL OR :P_CDALA = LEITO.CDALA ) AND ( :P_CDANDAR IS NULL OR :P_CDANDAR = LEITO.CDANDAR ) AND ( :P_CDPACIENTE IS NULL OR SERVINTE.CDPACIENTE = :P_CDPACIENTE ) AND ( INTERNAC.CDPACIENTE = SERVINTE.CDPACIENTE ) AND ( INTERNAC.CDLEITO = LEITO.CDLEITO ) AND ( INTERNAC.DTINTERNA = SERVINTE.DTINTERNA ) AND ( INTERNAC.CDFILIAL = SERVINTE.CDFILIAL ) AND ( SERVINTE.STPACIACOM <> '1' ) AND ( LEITO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( SERVINTE.CDPACIENTE = PACIENTE.CDPACIENTE ) AND ( SERVINTE.CDFILIAL = PACIENTE.CDFILIAL ) AND ( DIAGINTER.CDPACIENTE = INTERNAC.CDPACIENTE ) AND ( DIAGINTER.DTINTERNA = INTERNAC.DTINTERNA ) AND ( DIAGINTER.CDTABECDI = :P_CDTABECID ) AND ( DIAGINTER.CDFILIAL = SERVINTE.CDFILIAL ) AND ( DIAG.CDDIAGNOST = DIAGINTER.CDDIAGNOST ) AND ( DIAG.CDGRUPPROD = SUBGRUPPROD.CDGRUPPROD ) AND ( DIAG.CDSUBGRPROD = SUBGRUPPROD.CDSUBGRPROD ) ) A LEFT JOIN PRATO ON PRATO.CDPRATO = A.CDPRATO AND PRATO.CDFILAUXPRAT = A.CDFILAUXPRAT GROUP BY A.CDFILIAL, DTSERVINTE, CDANDAR, CDALA, CDLEITO, CDPACIENTE, CDSERVFILI, CDDIETPAD";
  const MP_TOT_DIETPLATE = "SELECT COUNT(CONFESCO.CDPRATO) AS QUANTIDADE, CONFESCO.CDPRATO, PRATO.NMPRATO, CONFESCO.CDFILAUXPRAT, LEITO.CDALA, LEITO.CDANDAR, SERVINTE.CDSERVFILI FROM SERVINTE, CONFESCO, PRATO, INTERNAC, LEITO WHERE ( SERVINTE.DTSERVINTE = :P_DTSERVINTE ) AND (SERVINTE.CDFILIAL = :P_CDFILIAL ) AND (SERVINTE.CDSERVFILI = :P_CDSERVFILI OR :P_CDSERVFILI = 'T' ) AND (LEITO.CDALA = :P_CDALA OR :P_CDALA = 'T' ) AND (LEITO.CDANDAR = :P_CDANDAR OR :P_CDANDAR = 'T' ) AND ( SERVINTE.CDPACIENTE = CONFESCO.CDPACIENTE ) AND ( SERVINTE.DTSERVINTE = CONFESCO.DTSERVINTE ) AND ( SERVINTE.NRSEQUSERV = CONFESCO.NRSEQUSERV ) AND ( CONFESCO.IDESCOCONF = 'S' ) AND ( INTERNAC.CDLEITO = LEITO.CDLEITO ) AND ( INTERNAC.CDFILIAL = SERVINTE.CDFILIAL ) AND ( SERVINTE.CDPACIENTE = INTERNAC.CDPACIENTE ) AND ( SERVINTE.DTINTERNA = INTERNAC.DTINTERNA ) AND ( LEITO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( CONFESCO.CDPRATO = PRATO.CDPRATO ) AND ( CONFESCO.CDFILIAL = SERVINTE.CDFILIAL ) AND ( CONFESCO.CDFILAUXPRAT = PRATO.CDFILAUXPRAT ) GROUP BY CONFESCO.CDPRATO, PRATO.NMPRATO, CONFESCO.CDFILAUXPRAT, LEITO.CDALA, LEITO.CDANDAR, SERVINTE.CDSERVFILI";
  const MP_DIET_TOT = "SELECT ALA.CDALA, ALA.NMALA, ANDAR.CDANDAR, ANDAR.NMANDAR, SERVINTE.CDFILIAL, SERVINTE.CDSERVFILI, SERVICO.NMSERVICO , SERVINTE.DTSERVINTE FROM ALA, ANDAR, SERVINTE, SERVICO, INTERNAC, LEITO WHERE (SERVINTE.DTSERVINTE = :P_DATAATUAL)                  AND (SERVINTE.CDFILIAL    = :P_CDFILIAL)                                         AND /* ((INSTR(:P_CDSERVFILI, SERVINTE.CDSERVFILI)<>0) OR :P_CDSERVFILI = 'T')      AND */ ((INSTR(:P_CDALA     , '_' || LEITO.CDALA || '_'   )<>0) OR :P_CDALA   = 'T')AND ((INSTR(:P_CDANDAR   , '_' || LEITO.CDANDAR || '_' )<>0) OR :P_CDANDAR = 'T')AND (INTERNAC.CDLEITO     = LEITO.CDLEITO)                    AND (INTERNAC.CDFILIAL    = SERVINTE.CDFILIAL)                AND (SERVINTE.CDPACIENTE  = INTERNAC.CDPACIENTE)              AND (SERVINTE.DTINTERNA   = INTERNAC.DTINTERNA)               AND (SERVINTE.CDFILIAL    = SERVICO.CDFILIAL)                 AND (SERVINTE.CDSERVFILI  = SERVICO.CDSERVFILI)               AND (LEITO.CDFILIAL       = SERVINTE.CDFILIAL)                AND (LEITO.CDALA          = ALA.CDALA)                        AND (LEITO.CDANDAR        = ANDAR.CDANDAR)                    AND (ALA.CDFILIAL         = SERVINTE.CDFILIAL)                AND (ANDAR.CDFILIAL       = SERVINTE.CDFILIAL) GROUP BY ALA.CDALA, ANDAR.CDANDAR, ALA.NMALA, ANDAR.NMANDAR, SERVINTE.CDFILIAL, SERVINTE.CDSERVFILI, SERVICO.NMSERVICO , SERVINTE.DTSERVINTE";
  
  const UPDATE_INTERNAC = "UPDATE INTERNAC SET IDMOTIALTA = :SITUATION, DTALTA = TO_DATE(:DISCHARGEDATE,'DD/MM/YYYY HH24:MI:SS') WHERE CDPACIENTE = :PATIENT AND DTINTERNA = (SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS )";
  const UPDATE_INTERNACLEITO = "UPDATE INTERNAC SET CDLEITO = :CDLEITO WHERE CDPACIENTE = :PATIENT AND DTINTERNA = (SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS )";
  const UPDATE_LEITO = "UPDATE LEITO SET IDOCUPLEITO = 'N' WHERE CDLEITO =: CDLEITO AND CDFILIAL =: CDFILIAL";
  const UPDATE_OCUPALEITO = "UPDATE LEITO SET IDOCUPLEITO = :IDOCUPLEITO WHERE CDLEITO = (SELECT CDLEITO FROM INTERNAC WHERE CDPACIENTE = :PATIENT AND DTINTERNA = (SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS ) AND CDFILIAL = :UNITS )";
  const UPDATE_FOOD_INTOLERANCE = "UPDATE DESCINTOPACI SET TXINTOALIM = UTL_RAW.CAST_TO_RAW(:FOODINTOLERANCE) WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS";
  const UPDATE_EATING_HABITS = "UPDATE DESCHABIPACI SET TXHABIALIM = UTL_RAW.CAST_TO_RAW(:EATINGHABITS), DSOBSCONFID = :CONFIDENTIALITY, DSOBSGERAL = :OBSERVATION WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS";
  const UPDATE_DIETETIC_PRESCRIPTION = "UPDATE PRESDIET SET CDDIETPAD = :CDDIETPAD, DSPRESDIET = :DSPRESDIET, DSDADOCLIN = :DSDADOCLIN, DSPRESMEDDIE = :DSPRESMEDDIE, CDNIASNUTR = :CDNIASNUTR WHERE CDPACIENTE = :OLD_CDPACIENTE AND DTPRESDIET = TO_DATE(:OLD_DTPRESDIET,'DD/MM/YYYY HH24:MI:SS') AND CDDIETPAD = :OLD_CDDIETPAD AND CDFILIAL = :OLD_CDFILIAL";
  const UPDATE_PRESCRIPTION_HOSPITALIZATION = "UPDATE INTERNAC SET CDLEITO = :BED WHERE CDPACIENTE = :PATIENT AND DTINTERNA = (SELECT MAX(DTINTERNA) FROM INTERNAC WHERE CDPACIENTE = :PATIENT AND CDFILIAL = :UNITS )";
  const UPDATE_PRESCRIPTION_BED = "UPDATE LEITO SET IDOCUPLEITO = :STATUS WHERE CDLEITO = :BED AND CDFILIAL = :UNIT";
  const UPDATE_APPOINTMENT = "UPDATE CONSPACI SET CDNIASNUTR =:CDNIASNUTR, CDEQUIMED =:CDEQUIMED, CDSERPADDIE =:CDSERPADDIE, CDDIETPAD =:CDDIETPAD, VRPESOPACI =:VRPESOPACI, VRALTURAPACI =:VRALTURAPACI WHERE CDPACIENTE =:OLD_CDPACIENTE AND DTCONSPACI = TO_DATE(:OLD_DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') AND CDFILIAL =:OLD_CDFILIAL";
  const UPDATE_DATA_INFO_EVALUATION = "UPDATE INFOAVAL SET DSINFOAVAL = :DSINFOAVAL WHERE CDFILIAL = :OLD_CDFILIAL AND CDPACIENTE = :OLD_CDPACIENTE AND DTCONSPACI = TO_DATE(:OLD_DTCONSPACI, 'DD/MM/YYYY HH24:MI:SS') AND CDTBMETOAVAL = :OLD_CDTBMETOAVAL AND CDTIPODADO = :OLD_CDTIPODADO";
  const UPDATE_BIOCHEMICAL_EVALUATION = "UPDATE EXAMREAL SET CDEXAME = :CDEXAME, NRSEMGEST = :NRSEMGEST, IDGRAVIDEZ = :IDGRAVIDEZ, DSRECLASSI   = :DSRECLASSI, VRRESEXA     = :VRRESEXA, NRSEQEXAMREA = :NRSEQEXAMREA WHERE CDPACIENTE   = :OLD_CDPACIENTE AND DTCONSPACI = TO_DATE(:OLD_DTCONSPACI,'DD/MM/YYYY HH24:MI:SS') AND CDEXAME    = :OLD_CDEXAME AND DTREALEX   = TO_DATE(:OLD_DTREALEX) AND CDFILIAL   = :OLD_CDFILIAL";
  const UPDATE_ENTERAL_FEEDING = "UPDATE CONFESCO SET CDFILAUXPRAT =:CDFILAUXPRAT, CDPRATO =:CDPRATO, DSOBSCONF =:DSOBSCONF, QTSERVCONF =:QTSERVCONF, QTPRATCONF =:QTPRATCONF, QTINFUCONF =:QTINFUCONF, HRCONSCONF =:HRCONSCONF, DTCONSCONF = TO_DATE(:DTCONSCONF,'DD/MM/YYYY'), CDPRODUTO =:CDPRODUTO, CDVIACESDIET =:CDVIACESDIET, IDPREPCONF =:IDPREPCONF WHERE CDPACIENTE =:OLD_CDPACIENTE AND DTSERVINTE = TO_DATE(:OLD_DTSERVINTE,'DD/MM/YYYY') AND NRSEQUSERV =:OLD_NRSEQUSERV AND CDSEQUCOPR =:OLD_CDSEQUCOPR AND CDFILIAL =:OLD_CDFILIAL";
  const UPDATE_LACTARY_FEEDING = "UPDATE CONFESCO SET DSOBSCONF =:DSOBSCONF, CDFILAUXPRAT =:CDFILAUXPRAT, CDPRATO =:CDPRATO, QTPRATCONF =:QTPRATCONF, HRCONSCONF =:HRCONSCONF, DTCONSCONF = TO_DATE(:DTCONSCONF,'DD/MM/YYYY') WHERE CDPACIENTE =:OLD_CDPACIENTE AND DTSERVINTE = TO_DATE(:OLD_DTSERVINTE,'DD/MM/YYYY') AND NRSEQUSERV =:OLD_NRSEQUSERV AND CDSEQUCOPR =:OLD_CDSEQUCOPR AND CDFILIAL =:OLD_CDFILIAL";
  const UPDATE_NORMAL_FEEDING = "UPDATE CONFESCO SET IDESCOCONF =:IDESCOCONF, IDRESTCONF = :IDRESTCONF, DSOBSCONF =:DSOBSCONF WHERE CDFILIAL =:OLD_CDFILIAL AND CDPACIENTE =:OLD_CDPACIENTE AND DTSERVINTE = TO_DATE(:OLD_DTSERVINTE,'DD/MM/YYYY') AND NRSEQUSERV =:OLD_NRSEQUSERV AND CDSEQUCOPR =:OLD_CDSEQUCOPR";
  const UPDATE_ANTH_EVALUATION_METHOD = "UPDATE METOAVAL SET IDTABELAAV = :IDTABELAAV, CDTABELACO =:CDTABELACO WHERE CDFILIAL = :OLD_CDFILIAL AND CDPACIENTE = :OLD_CDPACIENTE AND DTCONSPACI = TO_DATE(:OLD_DTCONSPACI, 'DD/MM/YYYY HH24:MI:SS') AND CDTBMETOAVAL = :OLD_CDTBMETOAVAL";
  const UPDATE_LAST_VISIT = "UPDATE PACIENTE SET DTULTATU = TO_DATE(:DTULTATU, 'DD/MM/YYYY HH24:MI:SS') WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE ";
  const UPDATE_CONFESCO_RESTRICTION = "UPDATE CONFESCO SET IDRESTCONF = :IDRESTCONF WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE AND DTSERVINTE = :DTSERVINTE AND NRSEQUSERV = :NRSEQUSERV AND CDSEQUCOPR = :CDSEQUCOPR";
  const UPDATE_SERVINTE_RESTRICTION = "UPDATE SERVINTE SET IDRESTSERIN = :IDRESTSERIN WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE AND DTSERVINTE = :DTSERVINTE AND NRSEQUSERV = :NRSEQUSERV";
  const UPDATE_SERVINTE_DELIVER = "UPDATE SERVINTE SET DTHRENTREGA = TO_DATE(:DTHRENTREGA,'DD/MM/YYYY HH24:MI:SS'), CDRESPENTREGA = :CDRESPENTREGA WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE AND DTSERVINTE = TO_DATE(:DTSERVINTE,'DD/MM/YYYY HH24:MI:SS') AND NRSEQUSERV = :NRSEQUSERV";
  const UPDATE_SERVINTE_COLLECT = "UPDATE SERVINTE SET DTHRRECOLHE = TO_DATE(:DTHRRECOLHE,'DD/MM/YYYY HH24:MI:SS'), CDRESPRECOLHE = :CDRESPRECOLHE WHERE CDFILIAL = :CDFILIAL AND CDPACIENTE = :CDPACIENTE AND DTSERVINTE = TO_DATE(:DTSERVINTE,'DD/MM/YYYY HH24:MI:SS') AND NRSEQUSERV = :NRSEQUSERV";
  
  const INSERT_ANTH_EVALUATION_METHOD = "INSERT INTO METOAVAL ( CDFILIAL, CDPACIENTE, DTCONSPACI, IDTABELAAV, CDTABELACO, CDTBMETOAVAL ) VALUES (:CDFILIAL, :CDPACIENTE, TO_DATE(:DTCONSPACI, 'DD/MM/YYYY HH24:MI:SS'), :IDTABELAAV, :CDTABELACO, :CDTBMETOAVAL)";
  const INSERT_BIOCHEMICAL_EVALUATION = "INSERT INTO EXAMREAL (DSRECLASSI,VRRESEXA,NRSEQEXAMREA,CDPACIENTE,DTCONSPACI,CDEXAME,DTREALEX,CDFILIAL,IDGRAVIDEZ, NRSEMGEST) VALUES (:DSRECLASSI,:VRRESEXA,:NRSEQEXAMREA,:CDPACIENTE,TO_DATE(:DTCONSPACI,'DD/MM/YYYY HH24:MI:SS'),:CDEXAME,TO_DATE(:DTREALEX,'DD/MM/YYYY HH24:MI:SS'),:CDFILIAL,:IDGRAVIDEZ, :NRSEMGEST)";
  const INSERT_APPOINTMENT = " INSERT INTO CONSPACI ( CDPACIENTE, DTCONSPACI, CDOPERADOR, CDFILIAL, NRORG, IDATIVO, CDNIASNUTR, CDEQUIMED, CDSERPADDIE, CDDIETPAD, VRPESOPACI, VRALTURAPACI ) VALUES ( :CDPACIENTE, TO_DATE(:DTCONSPACI,'DD/MM/YYYY HH24:MI:SS'), :CDOPERADOR, :CDFILIAL, :NRORG, :IDATIVO, :CDNIASNUTR, :CDEQUIMED, :CDSERPADDIE, :CDDIETPAD, :VRPESOPACI, :VRALTURAPACI )";
  const INSERT_FOOD_INTOLERANCE = "INSERT INTO DESCINTOPACI (CDPACIENTE, CDFILIAL, TXINTOALIM) VALUES (:PATIENT, :UNITS, utl_raw.cast_to_raw(:FOODINTOLERANCE))";
  const INSERT_EATING_HABITS = "INSERT INTO DESCHABIPACI( CDPACIENTE, CDFILIAL, TXHABIALIM, DSOBSCONFID, DSOBSGERAL) VALUES ( :PATIENT, :UNITS, utl_raw.cast_to_raw(:EATINGHABITS), :CONFIDENTIALITY, :OBSERVATION )";
  const INSERT_DIETETIC_PRESCRIPTION = "INSERT INTO PRESDIET ( CDPACIENTE, DTPRESDIET, CDDIETPAD, DSPRESDIET, DSDADOCLIN, DSPRESMEDDIE, CDFILIAL, CDNIASNUTR, CDLEITO ) VALUES ( :CDPACIENTE, TO_DATE(:DTPRESDIET,'DD/MM/YYYY HH24:MI:SS'), :CDDIETPAD, :DSPRESDIET, :DSDADOCLIN, :DSPRESMEDDIE, :CDFILIAL, :CDNIASNUTR, :CDLEITO)";
  const INSERT_ENTERAL_FEEDING = "INSERT INTO CONFESCO ( CDPACIENTE, DTSERVINTE, NRSEQUSERV, CDSEQUCOPR, CDFILAUXPRAT, CDPRATO, QTSERVCONF, QTPRATCONF, QTINFUCONF, HRCONSCONF, DTCONSCONF, CDPRODUTO, CDVIACESDIET, IDPREPCONF, DSOBSCONF, CDFILIAL ) VALUES ( :CDPACIENTE, TO_DATE(:DTSERVINTE,'DD/MM/YYYY'), :NRSEQUSERV, :CDSEQUCOPR, :CDFILAUXPRAT, :CDPRATO, :QTSERVCONF, :QTPRATCONF, :QTINFUCONF, :HRCONSCONF, TO_DATE(:DTCONSCONF,'DD/MM/YYYY'), :CDPRODUTO, :CDVIACESDIET, :IDPREPCONF, :DSOBSCONF, :CDFILIAL )";
  const INSERT_LACTARY_FEEDING = "INSERT INTO CONFESCO ( CDPACIENTE, DTSERVINTE, NRSEQUSERV, CDSEQUCOPR, DSOBSCONF, CDFILAUXPRAT, CDPRATO, QTPRATCONF, HRCONSCONF, DTCONSCONF, CDFILIAL ) VALUES ( :CDPACIENTE, TO_DATE(:DTSERVINTE,'DD/MM/YYYY'), :NRSEQUSERV, :CDSEQUCOPR, :DSOBSCONF, :CDFILAUXPRAT, :CDPRATO, :QTPRATCONF, :HRCONSCONF, TO_DATE(:DTCONSCONF,'DD/MM/YYYY'), :CDFILIAL )";
  const INSERT_NORMAL_FEEDING = "INSERT INTO CONFESCO ( CDPACIENTE, DTSERVINTE, NRSEQUSERV, CDSEQUCOPR, CDFILIAL, CDPRATO, CDTIPOPRAT, CDFILAUXPRAT, IDESCOCONF, IDOPCAOCONF, DSOBSCONF ) VALUES ( :CDPACIENTE, TO_DATE(:DTSERVINTE,'DD/MM/YYYY'), :NRSEQUSERV, :CDSEQUCOPR, :CDFILIAL, :CDPRATO, :CDTIPOPRAT, :CDFILAUXPRAT, :IDESCOCONF, :IDOPCAOCONF, :DSOBSCONF )";
  const INSERT_DATA_INFO_EVALUATION = "INSERT INTO INFOAVAL ( CDFILIAL, CDPACIENTE, DTCONSPACI, CDTBMETOAVAL, CDTIPODADO, DSINFOAVAL ) VALUES ( :CDFILIAL, :CDPACIENTE, TO_DATE(:DTCONSPACI, 'DD/MM/YYYY HH24:MI:SS'), :CDTBMETOAVAL, :CDTIPODADO, :DSINFOAVAL )";
  const INSERT_SERVINTE = "INSERT INTO SERVINTE ( CDPACIENTE, DTSERVINTE, NRSEQUSERV, CDFILIAL, CDSERVFILI, CDDIETPAD, NRACOMPANA, STPACIACOM, IDIMPRSERV, IDTIPOSERINT, IDRESTSERIN, CDNUTRICIO, CDDIETGRUPSI, DTINTERNA, DSSERVINTE, NRSERVPESO, DTINCLUSAO ) VALUES ( :CDPACIENTE, TO_DATE(:DTSERVINTE,'DD/MM/YYYY HH24:MI:SS'), :NRSEQUSERV, :CDFILIAL, :CDSERVFILI, :CDDIETPAD, :NRACOMPANA, :STPACIACOM, :IDIMPRSERV, :IDTIPOSERINT, :IDRESTSERIN, :CDNUTRICIO, :CDDIETGRUPSI, TO_DATE(:DTINTERNA,'DD/MM/YYYY HH24:MI:SS'), :DSSERVINTE, :NRSERVPESO, :DTINCLUSAO )";
  const INSERT_INTERNAC = "INSERT INTO INTERNAC(CDFILIAL, CDPACIENTE, DTINTERNA, DTALTA, CDEQUIMED, CDSERPADDIE, DSPRESMEDI, CDLEITO, IDMOTIALTA, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO) VALUES (:CDFILIAL, :CDPACIENTE, :DTINTERNA, :DTALTA, :CDEQUIMED, :CDSERPADDIE, :DSPRESMEDI, :CDLEITO, :IDMOTIALTA, :NRORG, :DTINCLUSAO, :DTULTATU, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :IDATIVO)";
  const INSERT_PATIENT = "INSERT INTO PACIENTE (CDFILIAL, CDPACIENTE, NMPACIENTE, NMSOBRNOME, NMPACIUPPER, DTNASCPACI, IDSEXOPACI, IDPACIENT, NRORG, DTULTATU) VALUES (:CDFILIAL, :CDPACIENTE, :NMPACIENTE, :NMSOBRNOME, :NMPACIUPPER, :DTNASCPACI, :IDSEXOPACI, 0, :NRORG, SYSDATE)";
  const INSERT_FOOD_INTOLERANCE_GROUP = "INSERT INTO INTOALIM  (CDFILIAL, CDPACIENTE, CDGRUPPROD, CDSUBGRPROD) VALUES (:CDFILIAL, :CDPACIENTE, :CDGRUPPROD, :CDSUBGRPROD)";
  
}